<?
class Acceso_Boletaje_clsProceso{
    public $pProcesoId;
    public $pTipo;
    public $pEmpresaId;
    public $pAlmacenId;
    public $pNombre;
    public $pTipoDocumentoId;
    public $pSerie;
    public $pNumero;
    public $pLimitarFechas;
    public $pDesde;
    public $pHasta;
    public $pImporteMaximo;
    public $pCantidadItems;
    public $pCantidadMaximaItem;
    public $pObservacion;
    public $pUsuarioId;
    public $pIP;
    public $pEstado;

    public $arrErrores=array();
    function __construct(){ $this->arrErrores=array( 999 => "", 100 => "Problemas al ejecutar la consulta." ); }
    function getErrMsg($vErrId){ return $this->arrErrores[intval($vErrId)]; }
    
    function Leer($vInicio, $vFin, $vEmpresaId=0, $vAlmacenId=0, $vTipo='', $vNombre=''){
        $oC= new Access_clsConexion();
        $vC="select * from boletaje.paproceso_leer(";
        $vC.=" ".intval($vInicio).",";
        $vC.=" ".intval($vFin).",";
        $vC.=" ".intval($vEmpresaId).",";
        $vC.=" ".intval($vAlmacenId).",";
        $vC.=" '".$oC->Escapar_Caracteres(trim($vTipo))."',";
        $vC.=" '".$oC->Escapar_Caracteres(trim($vNombre))."' ";
        $vC.=" )";
        return $oC->Ejecutar_Consulta($vC);
    }
    function Count($vEmpresaId, $vAlmacenId, $vTipo, $vNombre){
        $oC= new Access_clsConexion();
        $vC="select boletaje.paproceso_count(";
        $vC.=" ".intval($vEmpresaId).",";
        $vC.=" ".intval($vAlmacenId).",";
        $vC.=" '".$oC->Escapar_Caracteres(trim($vTipo))."',";
        $vC.=" '".$oC->Escapar_Caracteres(trim($vNombre))."' ";
        $vC.=" ) as count";
        $rs=$oC->Ejecutar_Consulta($vC);
        $vCount=0;
        if ($rs) {
            $row=$rs->fetch(PDO::FETCH_ASSOC);
            $vCount=intval($row['count']);
        }
        return $vCount;
    }
    function Agregar(&$vProcesoId, $vUsuarioId, $vIP){
        $oC= new Access_clsConexion();
        $vC="select * from boletaje.paproceso_actualizar(";
        $vC.=" true,";
        $vC.=" 0,";
        $vC.=" '".$oC->Escapar_Caracteres(trim($this->pTipo))."',";
        $vC.=" ".intval($this->pEmpresaId).",";
        $vC.=" ".intval($this->pAlmacenId).",";
        $vC.=" '".$oC->Escapar_Caracteres(trim($this->pNombre))."',";
        $vC.=" ".intval($this->pTipoDocumentoId).",";
        $vC.=" '".$oC->Escapar_Caracteres(trim($this->pSerie))."',";
        $vC.=" ".intval($this->pNumero).",";
        $vC.=" ".($this->pLimitarFechas?"true":"false").",";
        $vC.=" '".$oC->Escapar_Caracteres(trim($this->pDesde))."',";
        $vC.=" '".$oC->Escapar_Caracteres(trim($this->pHasta))."',";
        $vC.=" ".doubleval($this->pImporteMaximo).",";
        $vC.=" ".intval($this->pCantidadItems).",";
        $vC.=" ".intval($this->pCantidadMaximaItem).",";
        $vC.=" '".$oC->Escapar_Caracteres(trim($this->pObservacion))."',";
        $vC.=" ".intval($vUsuarioId).",";
        $vC.=" '".$oC->Escapar_Caracteres(trim($vIP))."' ";
        $vC.=" )";
        $rowRpta=$oC->Ejecutar_SQL2($vC);
        if ($rowRpta){
            if($rowRpta['outstate']){
                $vProcesoId=intval($rowRpta['outid']);
                return 0;
            }else{
                $this->arrErrores[999]=$rowRpta['outdescription'];
                return 999;
            }
        }else return 100;
    }
    function Modificar($vProcesoId, $vUsuarioId, $vIP){
        $oC= new Access_clsConexion();
        $vC="select * from boletaje.paproceso_actualizar(";
        $vC.=" false,";
        $vC.=" ".intval($vProcesoId).",";
        $vC.=" '".$oC->Escapar_Caracteres(trim($this->pTipo))."',";
        $vC.=" ".intval($this->pEmpresaId).",";
        $vC.=" ".intval($this->pAlmacenId).",";
        $vC.=" '".$oC->Escapar_Caracteres(trim($this->pNombre))."',";
        $vC.=" ".intval($this->pTipoDocumentoId).",";
        $vC.=" '".$oC->Escapar_Caracteres(trim($this->pSerie))."',";
        $vC.=" ".intval($this->pNumero).",";
        $vC.=" ".($this->pLimitarFechas?"true":"false").",";
        $vC.=" '".$oC->Escapar_Caracteres(trim($this->pDesde))."',";
        $vC.=" '".$oC->Escapar_Caracteres(trim($this->pHasta))."',";
        $vC.=" ".doubleval($this->pImporteMaximo).",";
        $vC.=" ".intval($this->pCantidadItems).",";
        $vC.=" ".intval($this->pCantidadMaximaItem).",";
        $vC.=" '".$oC->Escapar_Caracteres(trim($this->pObservacion))."',";
        $vC.=" ".intval($vUsuarioId).",";
        $vC.=" '".$oC->Escapar_Caracteres(trim($vIP))."' ";
        $vC.=" )";
        $rowRpta=$oC->Ejecutar_SQL2($vC);
        if ($rowRpta){
            if($rowRpta['outstate']){
                return 0;
            }else{
                $this->arrErrores[999]=$rowRpta['outdescription'];
                return 999;
            }
        }else return 100;
    }
    function Eliminar($vProcesoId, $vUsuarioId, $vIP){
        $oC= new Access_clsConexion();
        $vC="select * from boletaje.paproceso_eliminar(";
        $vC.=" ".intval($vProcesoId).",";
        $vC.=" ".intval($vUsuarioId).",";
        $vC.=" '".$oC->Escapar_Caracteres(trim($vIP))."' ";
        $vC.=" )";
        $rowRpta=$oC->Ejecutar_SQL2($vC);
        if ($rowRpta){
            if($rowRpta['outstate']){
                return 0;
            }else{
                $this->arrErrores[999]=$rowRpta['outdescription'];
                return 999;
            }
        }else return 100;
    }
    function getROW($vProcesoId){
        $oC= new Access_clsConexion();
        $vC="select * from boletaje.paproceso_getrow(".intval($vProcesoId).")";
        $rs=$oC->Ejecutar_Consulta($vC);
        if ($rs){
            if ($rs->rowCount()>0) return $rs->fetch(PDO::FETCH_ASSOC);
            else return false;
        }else return false;
    }
    function PorProcesar($vProcesoId){
        $oC= new Access_clsConexion();
        $vC="select * from boletaje.paproceso_porprocesar_leer(";
        $vC.=" ".intval($vProcesoId)." ";
        $vC.=" )";
        return $oC->Ejecutar_Consulta($vC);
    }
}
?>