<?
    header("Cache-Control: no-store, no-cache, must-revalidate");
    header("Pragma: no-cache");

    require_once("../../config.php");
    require_once(INTERFAZ."/seguridad.php");
    require_once(HERRAMIENTAS_PHP."/clsReniec.php");
    require_once(HERRAMIENTAS_PHP."/clsSunat.php");
    require_once(LOGICA."/Acceso.php");

    if ($_GET) $array=$_GET;
    else $array=$_POST;

    $miopcion=$array["miopcion"];
    switch($miopcion){
        case "getpersona":
            $vPersonaId=intval($array['personaid']);
            $arrData=getPersona($vPersonaId);
            echo json_encode($arrData);
            break;
        case "getproducto":
            $vProductoId=intval($array['productoid']);
            $arrData= getProducto($vProductoId);
            echo json_encode($arrData);
            break;
        case "getpersonabyid":
            $vPersonaId=intval($array['personaid']);
            $oP=new Acceso_clsPersona();
            $rowPersona=$oP->getROW($vPersonaId);
            $jsondata['rowPersona'] = $rowPersona;
            echo json_encode($jsondata);
            break;
        case "mostrar_provincias":
            $vDepartamentoId=intval($array['departamentoid']);
            $oP= new Acceso_clsProvincia();
            $rs=$oP->Leer($vDepartamentoId);

            $arrDatos=array(); if($rs) $arrDatos=$rs->fetchAll(PDO::FETCH_ASSOC);

            $jsondata['oData'] = $arrDatos;
            echo json_encode($jsondata);
            break;
        case "mostrar_distritos":
            $vDepartamentoId=intval($array['departamentoid']);
            $vProvinciaId=intval($array['provinciaid']);

            $oDis= new Acceso_clsDistrito();

            $rs=$oDis->Leer($vDepartamentoId, $vProvinciaId, "");

            $arrDatos=array(); if($rs) $arrDatos=$rs->fetchAll(PDO::FETCH_ASSOC);

            $jsondata['oData'] = $arrDatos;
            echo json_encode($jsondata);
            break;
        case "mostrar_menuweb":
            $oM=new Acceso_clsMenuWeb();
            $rs=$oM->Leer(-1);

            $arrDatos=array(); if($rs) $arrDatos=$rs->fetchAll(PDO::FETCH_ASSOC);

            $jsondata['oData'] = $arrDatos;
            $jsondata['oImages'] = IMAGES;
            echo json_encode($jsondata);
            break;
        case "mostrar_permisos_menuweb":
            $vPersonaId=intval($array['personaid']);

            $oP=new Acceso_clsPermisosWeb();

            $rsPermiso=$oP->Permisos_Usuario($vPersonaId);

            $arrPermiso=array(); if($rsPermiso) $arrPermiso=$rsPermiso->fetchAll(PDO::FETCH_ASSOC);

            $jsondata['oPermisos'] = $arrPermiso;
            echo json_encode($jsondata);
            break;
        case "consulta_personas":
            $vApePat=trim($array['apepat']);
            $vApeMat=trim($array['apemat']);
            $vNombre=trim($array['nombre']);
            $vOpcion=trim($array['opcion']);
            $vLimite=intval($array['limite']);
            $vPersonaId=intval($array['personaid']);
            $oP=new Acceso_clsPersona();
            $rs=$oP->Consulta($vApePat, $vApeMat, $vNombre, $vOpcion, "null", $vLimite, $vPersonaId);

            $arrDatos=array(); if ($rs) $arrDatos=$rs->fetchAll(PDO::FETCH_ASSOC);

            $jsondata['oData'] = $arrDatos;
            $jsondata['oImages'] = IMAGES;
            $jsondata['oPathPhoto'] = "http://".FTP_DOMAIN.FTP_DIR.PATH_PERSON_PHOTO;
            echo json_encode($jsondata);
            break;
        case "getidbydni":
            $vDNI=trim($array['dni']);
            $vGetCaptcha=(intval($array['getcaptcha'])==1);
            $oP=new Acceso_clsPersona();

            $vPersonaId=$oP->getIDBYDNI($vDNI);

            $rowPersona=$oP->getROW($vPersonaId);

            $vCookieTemp=""; $vImagenCaptcha="";
            if($vGetCaptcha){
                $oR=new clsReniec();
                $vImagenCaptcha=$oR->getCaptcha($vCookieTemp);
            }

            $jsondata['rowPersona'] = $rowPersona;
            $jsondata['oImage'] = $vImagenCaptcha;
            $jsondata['oCookie'] = $vCookieTemp;
            echo json_encode($jsondata);
            break;
        case "reniec-captcha":
            $oR=new clsReniec();
            $vCookieTemp="";
            $vImagenCaptcha=$oR->getCaptcha($vCookieTemp);

            $jsondata['oImage'] = $vImagenCaptcha;
            $jsondata['oCookie'] = $vCookieTemp;
            echo json_encode($jsondata);
            break;
        case "reniec-data":
            $vDNI=trim($array['dni']);
            $vCapcha=trim($array['captcha']);
            $vFileNameCookie=trim($array['cookie']);
            $vFileNameImage=trim($array['imagename']);

            $oR=new clsReniec();
            $myArr=$oR->getNombre($vFileNameCookie, $vDNI, $vCapcha);

            if(is_file($vFileNameImage))unlink($vFileNameImage);

            $vApePat=$vApeMat=$vNombre="";
            $intError=0; $msgError="";
            if(isset($myArr['error'])){
                $intError=1; $msgError=trim($myArr['descripcion']);
            }else{
                $vApePat=utf8_encode($myArr['ape_pat']);
                $vApeMat=utf8_encode($myArr['ape_mat']);
                $vNombre=utf8_encode($myArr['nombre']);
            }

            $oP=new Acceso_clsPersona();
            $vPersonaId=$oP->getIDBYDNI($vDNI);

            $jsondata['oErr'] = $intError;
            $jsondata['oDescription'] = $msgError;
            $jsondata['oDNI'] = $vDNI;
            $jsondata['oApePat'] = $vApePat;
            $jsondata['oApeMat'] = $vApeMat;
            $jsondata['oNombre'] = $vNombre;
            $jsondata['oPersonaId'] = $vPersonaId;
            echo json_encode($jsondata);
            break;
        case "sunat":
            $vRUC=trim($array['ruc']);

            $oS=new clsSunat();
            $myArr=$oS->getRazSoc($vRUC);

            $jsondata['oErr'] = 0;
            $jsondata['oDescription'] = "";
            $jsondata['oRazSoc'] = $myArr['raz_soc'];
            $jsondata['oDireccion'] = $myArr['direccion'];
            echo json_encode($jsondata);
            break;
        case "config_subgrupos":
            $vConfigGroupId=intval($array['configgroupid']);

            $oG=new Acceso_clsConfigSubGroup();

            $rs=$oG->Read(0, 0, $vConfigGroupId, "");

            $arrData=array(); if($rs) $arrData=$rs->fetchAll(PDO::FETCH_ASSOC);

            $jsondata['oData'] = $arrData;
            $jsondata['oImages'] = IMAGES;
            echo json_encode($jsondata);
            break;
        case "subcategoria-show":
            $vCategoriaId=intval($array['categoriaid']);

            $oSC=new Acceso_Catalogo_clsSubCategoria();

            $rs=$oSC->Leer("", $vCategoriaId);

            $arrData=array(); if($rs) $arrData=$rs->fetchAll(PDO::FETCH_ASSOC);

            $jsondata['oData'] = $arrData;
            $jsondata['oImages'] = IMAGES;
            echo json_encode($jsondata);
            break;
        case "serie-show":
            $vAlmacenId=intval($array['almacenid']);

            $oS=new Acceso_Tesoreria_clsSerie();

            $rs=$oS->Consultar($vAlmacenId);

            $arrData=array(); if($rs) $arrData=$rs->fetchAll(PDO::FETCH_ASSOC);

            $jsondata['oData'] = $arrData;
            $jsondata['oImages'] = IMAGES;
            echo json_encode($jsondata);
            break;
        case "getordencompra":
            $vOrdenCompraId=intval($array['ordencompraid']);
            
            $oOC=new Acceso_clsOrdenCompra();
            
            $rowOrdCom=$oOC->getROW($vOrdenCompraId);
            $vPersonaId=intval($rowOrdCom['proveedorid']);
            $rsItems=$oOC->LeerItems($vOrdenCompraId);
            
            $arrItemsAux=array(); if($rsItems) $arrItemsAux=$rsItems->fetchAll(PDO::FETCH_ASSOC);
            $arrItems=array();
            foreach($arrItemsAux as $i=>$row){
                $arrItems[]=array("productoid"=>$row['productoid'], "producto_nombre"=>$row['producto'], "cantidad"=>$row['cantidad'], "precio"=>$row['precio'], "total"=>($row['cantidad']*$row['precio']));
            }
            
            $vDetalles="";
            if($rowOrdCom){
                $vDetalles="OC - ". str_pad(intval($rowOrdCom['correlativo']), 8, "0", STR_PAD_LEFT);
            }
            
            $arrData['oOrdenCompraId']=$vOrdenCompraId;
            $arrData['oDetalles']=$vDetalles;
            $arrData['oItems']=$arrItems;
            $arrData['oPersonaId']=$vPersonaId;
            $arrData['rowPersona']=getPersona($vPersonaId);
            echo json_encode($arrData);
            break;
        case "almacen-show":
            $vEmpresaId=intval($array['empresaid']);
            $vZonaId=intval($array['zonaid']);

            $oA=new Acceso_clsPermisos_Almacen();

            $rs=$oA->LeerAlmacenes($vEmpresaId, $sessCodigo, 0, $vZonaId);

            $arrData=array(); if($rs) $arrData=$rs->fetchAll(PDO::FETCH_ASSOC);

            $jsondata['oData'] = $arrData;
            $jsondata['oImages'] = IMAGES;
            echo json_encode($jsondata);
            break;
        case "almacen-show-all":
            $vZonaId=intval($array['zonaid']);

            $oA=new Acceso_clsAlmacen();

            $rs=$oA->Leer($vZonaId);

            $arrData=array(); if($rs) $arrData=$rs->fetchAll(PDO::FETCH_ASSOC);

            $jsondata['oData'] = $arrData;
            $jsondata['oImages'] = IMAGES;
            echo json_encode($jsondata);
            break;
    }
?>