<?
    header("Cache-Control: no-store, no-cache, must-revalidate");
    header("Pragma: no-cache");

    require_once("../../../config.php");
    require_once(INTERFAZ."/seguridad.php");
    require_once(LOGICA."/Acceso.php");

    if ($_GET) $array=$_GET;
    else $array=$_POST;

    $miopcion=$array["miopcion"];
    switch($miopcion){
        case "venmen-show":
            $vEmpresaId=intval($array['empresaid']);
            $vTipo=intval($array['tipo']);
            $vAno=intval($array['ano']);
            $vZonaId=intval($array['zonaid']);
            
            $oA=new Acceso_clsPermisos_Almacen();
            $oR=new Acceso_Inventarios_clsReportes();

            $rsAlm=$oA->LeerAlmacenes($vEmpresaId, $sessCodigo, 0, $vZonaId);
            $rsRpt=$oR->VentasMensuales($vEmpresaId, $vTipo, $vAno, $vZonaId, 0);

            $arrAlm=array(); if($rsAlm) $arrAlm=$rsAlm->fetchAll(PDO::FETCH_ASSOC);
            $arrAux=array(); if($rsRpt) $arrAux=$rsRpt->fetchAll(PDO::FETCH_ASSOC);
            
            $arrData=array();
            foreach($arrAux as $i=>$row){
                $arrData[$row['almacenid']][$row['mes']]=doubleval($row['total']);
            }
            
            $arrMes=array();
            for($vMes=1; $vMes<=intval(date('m')); $vMes++){
                $arrMes[$vMes]=array("mesid"=>$vMes, "nombre"=> strtoupper(MonthName($vMes, false)), "abreviatura"=>strtoupper(MonthName($vMes, true)));
            }
            
            $jsondata['oData'] = $arrData;
            $jsondata['oAlmacen'] = $arrAlm;
            $jsondata['oMes'] = $arrMes;
            $jsondata['oImages'] = IMAGES;
            echo json_encode($jsondata);
            break;
            
            
        case "vendia-show":
            $vEmpresaId=intval($array['empresaid']);
            $vTipo=intval($array['tipo']);
            $vZonaId=intval($array['zonaid']);
            $vDesde=CDate($array['desde']);
            $vHasta=CDate($array['hasta']);
            
            $oA=new Acceso_clsPermisos_Almacen();
            $oR=new Acceso_Inventarios_clsReportes();

            $rsAlm=$oA->LeerAlmacenes($vEmpresaId, $sessCodigo, 0, $vZonaId);
            $rsRpt=$oR->VentasDiarias($vEmpresaId, $vTipo, $vZonaId, $vDesde, $vHasta);

            $arrAlm=array(); if($rsAlm) $arrAlm=$rsAlm->fetchAll(PDO::FETCH_ASSOC);
            $arrAux=array(); if($rsRpt) $arrAux=$rsRpt->fetchAll(PDO::FETCH_ASSOC);
            
            $arrData=array();
            foreach($arrAux as $i=>$row){
                $arrData[$row['almacenid']][$row['ano']][$row['mes']][$row['dia']]=doubleval($row['total']);
            }
            
            $arrDias= getDaysRange($vDesde, $vHasta);
            
            $jsondata['oFechas'] = $arrDias;
            $jsondata['oData'] = $arrData;
            $jsondata['oAlmacen'] = $arrAlm;
            $jsondata['oImages'] = IMAGES;
            echo json_encode($jsondata);
            break;
            
        case "productos-mas-vendidos":
            $vEmpresaId=intval($array['empresaid']);
            $vZonaId=intval($array['zonaid']);
            $vAlmacenId=intval($array['almacenid']);
            $vDesde=trim($array['desde']); if(trim($vDesde)!='')$vDesde=CDate($array['desde']);
            $vHasta=trim($array['hasta']); if(trim($vHasta)!='')$vHasta=CDate($array['hasta']);
            $vCondicion=trim($array['condicion']);
            $vPersonaId=intval($array['presonaid']);
            
            $oA=new Acceso_clsPermisos_Almacen();
            $oR=new Acceso_Inventarios_clsReportes();

            $rsZon=$oA->LeerZonas($vEmpresaId, $sessCodigo, 0, $vZonaId);
            $rsAlm=$oA->LeerAlmacenes($vEmpresaId, $sessCodigo, 0, $vZonaId);
            $rsPro=$oR->ProductosMasVendidos($vEmpresaId, $vZonaId, $vAlmacenId, $vTipoDocumentoId, $vCondicion, $vPersonaId, $vDesde, $vHasta);
            $rsRpt=$oR->ProductosMasVendidosDetalle($vEmpresaId, $vZonaId, $vAlmacenId, $vTipoDocumentoId, $vCondicion, $vPersonaId, $vDesde, $vHasta);

            $arrZon=array(); if($rsZon) $arrZon=$rsZon->fetchAll(PDO::FETCH_ASSOC);
            $arrAlm=array(); if($rsAlm) $arrAlm=$rsAlm->fetchAll(PDO::FETCH_ASSOC);
            $arrPro=array(); if($rsPro) $arrPro=$rsPro->fetchAll(PDO::FETCH_ASSOC);
            $arrAux=array(); if($rsRpt) $arrAux=$rsRpt->fetchAll(PDO::FETCH_ASSOC);
            
            $arrAlmAux=array(); foreach($arrAlm as $iAlm=>$rowAlm){ $arrAlmAux[$rowAlm['zonaid']][]=$rowAlm; }
            foreach($arrZon as $iZon=>$rowZon){
                $arrZon[$iZon]['oAlmacen']=(isset($arrAlmAux[$rowZon['zonaid']])?$arrAlmAux[$rowZon['zonaid']]:array());
            }
            
            $arrData=array();
            foreach($arrAux as $i=>$row){
                $arrData[$row['productoid']][$row['almacenid']]=array("cantidad"=>doubleval($row['cantidad']), "total"=>doubleval($row['total']));
            }
            
            $jsondata['oData'] = $arrData;
            $jsondata['oProducto'] = $arrPro;
            $jsondata['oZona'] = $arrZon;
            $jsondata['oImages'] = IMAGES;
            echo json_encode($jsondata);
            break;


        case "stock":
            $vEmpresaId=intval($array['empresaid']);
            $vZonaId=intval($array['zonaid']);
            $vAno=intval($array['ano']);
            
            $oA=new Acceso_clsPermisos_Almacen();
            $oP=new Acceso_clsProducto();
            $oR=new Acceso_Inventarios_clsReportes();
            
            $rsZon=$oA->LeerZonas($vEmpresaId, $sessCodigo, 0, $vZonaId);
            $rsAlm=$oA->LeerAlmacenes($vEmpresaId, $sessCodigo, 0, $vZonaId);
            $rsPro=$oP->Consulta($vAno, $vEmpresaId,0,0,'',0,'','');
            $rsRpt=$oR->StockGeneral($vAno, $vEmpresaId, $vZonaId);

            $arrZon=array(); if($rsZon) $arrZon=$rsZon->fetchAll(PDO::FETCH_ASSOC);
            $arrAlm=array(); if($rsAlm) $arrAlm=$rsAlm->fetchAll(PDO::FETCH_ASSOC);
            $arrPro=array(); if($rsPro) $arrPro=$rsPro->fetchAll(PDO::FETCH_ASSOC);
            $arrAux=array(); if($rsRpt) $arrAux=$rsRpt->fetchAll(PDO::FETCH_ASSOC);
            
            $arrAlmAux=array(); foreach($arrAlm as $iAlm=>$rowAlm){ $arrAlmAux[$rowAlm['zonaid']][]=$rowAlm; }
            foreach($arrZon as $iZon=>$rowZon){
                $arrZon[$iZon]['oAlmacen']=(isset($arrAlmAux[$rowZon['zonaid']])?$arrAlmAux[$rowZon['zonaid']]:array());
            }
            
            $arrData=array();
            foreach($arrAux as $i=>$row){
                $arrData[$row['productoid']][$row['almacenid']]=doubleval($row['stock']);
            }
            
            $jsondata['oData'] = $arrData;
            $jsondata['oProducto'] = $arrPro;
            $jsondata['oZona'] = $arrZon;
            $jsondata['oImages'] = IMAGES;
            echo json_encode($jsondata);
            break;
            
    }
?>
