<?
    header("Cache-Control: no-store, no-cache, must-revalidate"); 
    header("Pragma: no-cache");

    require_once("../../config.php");
    require_once(INTERFAZ."/seguridad.php");
    require_once(LOGICA."/Acceso.php");
    require_once(HERRAMIENTAS_PHP."/pdf.php");
    require_once(HERRAMIENTAS_PHP."/tcpdf/config/lang/eng.php");
    require_once(HERRAMIENTAS_PHP."/tcpdf/tcpdf.php");
    require_once(HERRAMIENTAS_PHP."/FunctionsPDF.php");

    class MYPDF extends TCPDF {	
        public $pTitulo;
        public $pSubTitulo;
        public $pDescripcion;
        public $rowWidth;
        public $pUsuario;

        public function Header() {
            $wAux=getPageWidth($this);
            $this->SetFillColor(240);
            $hAux=6; $this->Cell(0, $hAux, ""); $this->Ln($hAux);
            $hAux=7; PrintCell($this, $this->pTitulo, $wAux, $hAux, 10, 1, "C", true, 'B'); $this->Ln($hAux);
            $hAux=7; PrintCell($this, $this->pSubTitulo, ($wAux/2), $hAux, 10, 1, "L", false, 'B');
            $hAux=7; PrintCell($this, $this->pDescripcion, ($wAux/2), $hAux, 10, 1, "R", false, 'B'); $this->Ln($hAux);
            
            $this->SetFont('helvetica', 'B', 8);
            $hAux=5; $vColsAux=2;
            $vX=$this->getX();
            $vY=$this->getY();
            PrintCell($this, "N°", $this->rowWidth['orden'], $hAux*$vColsAux, 8, 1, 'C', true, "B");
            PrintCell($this, " FECHA", $this->rowWidth['fecha'], $hAux*$vColsAux, 8, 1, 'L', true, "B");
            PrintCell($this, " PERSONA", $this->rowWidth['producto'], $hAux*$vColsAux, 8, 1, 'L', true, "B");
            PrintCell($this, " NUMERO", $this->rowWidth['numero'], $hAux*$vColsAux, 8, 1, 'L', true, "B");
            PrintCell($this, " ALM", $this->rowWidth['almacen'], $hAux*$vColsAux, 8, 1, 'L', true, "B");
            PrintCell($this, "INGRESOS", $this->rowWidth['importe']*4, $hAux, 8, 1, 'C', true, "B");
            PrintCell($this, "SALIDAS", $this->rowWidth['importe']*4, $hAux, 8, 1, 'C', true, "B");
            PrintCell($this, "SALDOS", $this->rowWidth['importe']*3, $hAux, 8, 1, 'C', true, "B");

            
            $this->SetXY($vX+$this->rowWidth['orden']+$this->rowWidth['fecha']+$this->rowWidth['producto']+$this->rowWidth['numero']+$this->rowWidth['almacen'], $vY+$hAux);
            PrintCell($this, "CANT ", $this->rowWidth['importe'], $hAux, 8, 1, 'R', true, "B");
            PrintCell($this, "PRECIO ", $this->rowWidth['importe'], $hAux, 8, 1, 'R', true, "B");
            PrintCell($this, "TOTAL ", $this->rowWidth['importe'], $hAux, 8, 1, 'R', true, "B");
            PrintCell($this, "BONIF ", $this->rowWidth['importe'], $hAux, 8, 1, 'R', true, "B");

            PrintCell($this, "CANT ", $this->rowWidth['importe'], $hAux, 8, 1, 'R', true, "B");
            PrintCell($this, "PRECIO ", $this->rowWidth['importe'], $hAux, 8, 1, 'R', true, "B");
            PrintCell($this, "TOTAL ", $this->rowWidth['importe'], $hAux, 8, 1, 'R', true, "B");
            PrintCell($this, "BONIF ", $this->rowWidth['importe'], $hAux, 8, 1, 'R', true, "B");

            PrintCell($this, "CANT ", $this->rowWidth['importe'], $hAux, 8, 1, 'R', true, "B");
            PrintCell($this, "PRECIO ", $this->rowWidth['importe'], $hAux, 8, 1, 'R', true, "B");
            PrintCell($this, "TOTAL ", $this->rowWidth['importe'], $hAux, 8, 1, 'R', true, "B");
            
        }
        public function Footer(){
            $this->SetY(-15);
            $this->SetFont('helvetica', 'I', 7);
            $this->Cell(0,10, date('d/m/Y h:i:s a')."   USUARIO: ".$this->pUsuario, "T", 0, 'L');
            $this->Cell(0,10,'Pagina '.$this->PageNo().'/'.$this->getAliasNbPages(),0,0,'R');
        }
    }

    //BEGIN OBTENIENDO VALORES
    $array=$_GET;
    $vProductoId=intval($array['productoid']);
    $vZonaId=intval($array['zonaid']);
    $vAlmacenId=intval($array['almacenid']);
    $vAno=intval($array['ano']);

    $oZ=new Acceso_clsZona();
    $oA=new Acceso_clsAlmacen();
    $oP=new Acceso_clsProducto();
    $oR=new Acceso_Inventarios_clsReportes();

    $rowProducto=$oP->getROW($vProductoId);
    $vZonaNombre="TODAS LAS ZONAS";
    if($vZonaId>0){
        $rowZona=$oZ->getROW($vZonaId);
        $vZonaNombre=$rowZona['nombre'];
    }
    $vAlmacenNombre="TODOS LOS ALMACENES";
    if($vAlmacenId>0){
        $rowAlm=$oA->getROW($vAlmacenId);
        $vAlmacenNombre=$rowAlm['nombre'];
    }

    $rsRpt=$oR->KardexPromedio($vProductoId, $vZonaId, $vAlmacenId, $vAno, $sessCodigo);

    $arrData=array(); if($rsRpt) $arrData=$rsRpt->fetchAll(PDO::FETCH_ASSOC);

    //BEGIN PDF
    $pdf = new MYPDF("P", PDF_UNIT, PDF_PAGE_FORMAT, true, 'UTF-8', false); 
    $pdf->SetCreator(PDF_CREATOR);
    $pdf->setPrintHeader(true);
    $pdf->setPrintFooter(true);
    $pdf->SetDefaultMonospacedFont(PDF_FONT_MONOSPACED);
    $pdf->SetMargins(5, 30, 5);
    $pdf->SetHeaderMargin(0);
    $pdf->SetFooterMargin(0);
    $pdf->SetAutoPageBreak(true, 15);
    $pdf->setImageScale(PDF_IMAGE_SCALE_RATIO); 
    $pdf->setLanguageArray($l); 
    $pdf->SetTitle('KARDEX / '.$rowProducto['nombre']." / AÑO ".$vAno);
    $pdf->pUsuario=$sessUsuario;
    $pdf->pTitulo='KARDEX / AÑO '.$vAno;
    $pdf->pSubTitulo=" ".$rowProducto['productoid'].": ".$rowProducto['nombre'];
    $pdf->pDescripcion=$vZonaNombre." / ".$vAlmacenNombre." ";

    $wPage=getPageWidth($pdf);
    $hPage=getPageHeight($pdf);

    $wOrd=6; $wFecha=17; $wPersona=70; $wDetalle=30; $wAlmacen=15; $wColData=14; $vCols=11;
    $wData=$wPage-$wOrd-$wFecha-$wPersona-$wDetalle-$wAlmacen;
    
    $wColDataAux=($wData/$vCols);
    if($wColDataAux>$wColData){//SOBRA
        $wPersona=$wPage-($wColData*$vCols)-$wOrd-$wFecha-$wDetalle-$wAlmacen;
    }else{
        $pdf->setPageOrientation("L");
        $wPage=getPageWidth($pdf);
        $wData=$wPage-$wOrd-$wFecha-$wPersona-$wDetalle-$wAlmacen;
        $wColDataAux=($wData/$vCols);
        if($wColDataAux>$wColData){//SOBRA
            $wPersona=$wPage-($wColData*$vCols)-$wOrd-$wFecha-$wDetalle-$wAlmacen;
        }else{
            $wColData=$wColDataAux;
        }
    }

    $rowWidth=array("orden"=>$wOrd, "fecha"=>$wFecha, "producto"=>$wPersona, "numero"=>$wDetalle, "almacen"=>$wAlmacen, "importe"=>$wColData);
    $pdf->rowWidth=$rowWidth;

    $fsSize=8; $hRowDet=5;
    $hNow=0;
    $pdf->SetFont('helvetica', '', $fsSize);
    
    $pdf->SetFillColor(240);
    
    $pdf->AddPage();

    $vContador=0;
    $pdf->SetFillColor(240);
    $arrTotales=array();
    if(count($arrData)>0){
        foreach($arrData as $iData=>$rowData){
            $vContador++;

            $pdf->SetFont('helvetica', '', $fsSize);

            PrintCell($pdf, $vContador, $rowWidth['orden'], $hRowDet, $fsSize, 1, 'C');
            PrintCell($pdf, FormatDate($rowData['fecha']), $rowWidth['fecha'], $hRowDet, $fsSize, 1, 'L');
            PrintCell($pdf, $rowData['persona_nombre'], $rowWidth['producto'], $hRowDet, $fsSize, 1, 'L');
            PrintCell($pdf, $rowData['numero'], $rowWidth['numero'], $hRowDet, $fsSize, 1, 'L');
            PrintCell($pdf, $rowData['almacen_abreviatura'], $rowWidth['almacen'], $hRowDet, $fsSize, 1, 'L');
            if(intval($rowData['tipo'])==0){
                PrintCell($pdf, number_format($rowData['ingreso_cantidad'],2), $rowWidth['importe'], $hRowDet, $fsSize, 1, 'R');
                PrintCell($pdf, number_format($rowData['ingreso_precio'],2), $rowWidth['importe'], $hRowDet, $fsSize, 1, 'R');
                PrintCell($pdf, number_format($rowData['ingreso_total'],2), $rowWidth['importe'], $hRowDet, $fsSize, 1, 'R');
                PrintCell($pdf, number_format($rowData['ingreso_cantidad_bonif'],2), $rowWidth['importe'], $hRowDet, $fsSize, 1, 'R');
            }else{
                PrintCell($pdf, "", $rowWidth['importe'], $hRowDet, $fsSize, 1, 'R');
                PrintCell($pdf, "", $rowWidth['importe'], $hRowDet, $fsSize, 1, 'R');
                PrintCell($pdf, "", $rowWidth['importe'], $hRowDet, $fsSize, 1, 'R');
                PrintCell($pdf, "", $rowWidth['importe'], $hRowDet, $fsSize, 1, 'R');
            }
            if(intval($rowData['tipo'])==1){
                PrintCell($pdf, number_format($rowData['salida_cantidad'],2), $rowWidth['importe'], $hRowDet, $fsSize, 1, 'R');
                PrintCell($pdf, number_format($rowData['salida_precio'],2), $rowWidth['importe'], $hRowDet, $fsSize, 1, 'R');
                PrintCell($pdf, number_format($rowData['salida_total'],2), $rowWidth['importe'], $hRowDet, $fsSize, 1, 'R');
                PrintCell($pdf, number_format($rowData['salida_cantidad_bonif'],2), $rowWidth['importe'], $hRowDet, $fsSize, 1, 'R');
            }else{
                PrintCell($pdf, "", $rowWidth['importe'], $hRowDet, $fsSize, 1, 'R');
                PrintCell($pdf, "", $rowWidth['importe'], $hRowDet, $fsSize, 1, 'R');
                PrintCell($pdf, "", $rowWidth['importe'], $hRowDet, $fsSize, 1, 'R');
                PrintCell($pdf, "", $rowWidth['importe'], $hRowDet, $fsSize, 1, 'R');
            }
            PrintCell($pdf, number_format($rowData['saldo_cantidad'],2), $rowWidth['importe'], $hRowDet, $fsSize, 1, 'R');
            PrintCell($pdf, number_format($rowData['saldo_precio'],2), $rowWidth['importe'], $hRowDet, $fsSize, 1, 'R');
            PrintCell($pdf, number_format($rowData['saldo_total'],2), $rowWidth['importe'], $hRowDet, $fsSize, 1, 'R');
            
            $pdf->Ln($hRowDet);
        }
    }
    
    $pdf->Output('KARDEX-'.intval($rowProducto['productoid']).'-'.strtoupper(FileName($rowProducto['nombre'])).'-ANO-'.$vAno.'.pdf', 'I');
    ?>