<?
    header("Cache-Control: no-store, no-cache, must-revalidate"); 
    header("Pragma: no-cache");

    require_once("../../config.php");
    require_once(INTERFAZ."/seguridad.php");
    require_once(LOGICA."/Acceso.php");
    require_once(HERRAMIENTAS_PHP."/pdf.php");
    require_once(HERRAMIENTAS_PHP."/tcpdf/config/lang/eng.php");
    require_once(HERRAMIENTAS_PHP."/tcpdf/tcpdf.php");
    require_once(HERRAMIENTAS_PHP."/FunctionsPDF.php");
    require_once(HERRAMIENTAS_PHP."/OrdenCompra.php");

    class MYPDF extends TCPDF{
        public function Header(){ }
        public function Footer(){ }
    }
    
    //BEGIN OBTENIENDO VALORES
    $array=$_GET;
    $vOrdenCompraId=intval($array["ordencompraid"]);
    //END OBTENIENDO VALORES

    //BEGIN DATA
    $oOC=new Acceso_clsOrdenCompra();
    $oEmp=new Acceso_clsEmpresa();
    $oConfig=new Acceso_clsConfig();

    $rowOrden=$oOC->getROW($vOrdenCompraId);
    $vEmpresaId=intval($rowOrden['empresaid']);
    $rowEmpresa=$oEmp->getROW($vEmpresaId);
    $rsItems=$oOC->LeerItems($vOrdenCompraId);

    $arrData=array(); if($rsItems) $arrData=$rsItems->fetchAll(PDO::FETCH_ASSOC);
    
    foreach($arrData as $iIndice=>$rowData){
        $arrData[$iIndice]['cantidad_aux']=number_format($rowData['cantidad'], 2, ".", ",");
        $arrData[$iIndice]['valor_venta_aux']=number_format($rowData['valor_venta'], 4, ".", ",");
        $arrData[$iIndice]['total_aux']=number_format($rowData['total'], 2, ".", ",");
    }
    //END DATA

    
    //BEGIN CONFIGRACION DEL FORMATO
    $rsConfig=$oConfig->Query("reportes", "tesoreria-ingresos-detallados", '');
    $arrConfigAux=array(); if($rsConfig) $arrConfigAux=$rsConfig->fetchAll(PDO::FETCH_ASSOC);
    $arrConfigCols=array(); foreach($arrConfigAux as $ia=>$row){ $arrConfigCols[$row['configvars_name']]=$row['valor']; }
    $vFontFamily=(trim($arrConfigCols['font-family'])==''?'Helvetica':trim($arrConfigCols['font-family']));
    $fsData=(doubleval($arrConfigCols['font-size-data'])<=0?8:doubleval($arrConfigCols['font-size-data']));
    $hRowData=(doubleval($arrConfigCols['height-row-data'])<=0?5:doubleval($arrConfigCols['height-row-data']));
    $vBorderData=(intval($arrConfigCols['border-data'])==1?1:0);
    $swPintarData=(intval($arrConfigCols['pintar-data'])==1);
    //END CONFIGRACION DEL FORMATO

    $arrCols[]=array('name'=>'', 'caption'=>'N°', 'align'=>'C', 'width'=>7, 'tipo'=>'NO');
    $arrCols[]=array('name'=>'productoid', 'caption'=>'CODIGO', 'align'=>'C', 'width'=>20, 'tipo'=>'');
    $arrCols[]=array('name'=>'producto', 'caption'=>' DESCRIPCION', 'align'=>'L', 'width'=>70, 'tipo'=>'', 'fitwidth'=>100);
    $arrCols[]=array('name'=>'unidadmedida_abreviatura', 'caption'=>' U.M.', 'align'=>'C', 'width'=>20, 'tipo'=>'');
    $arrCols[]=array('name'=>'cantidad_aux', 'caption'=>'CANTIDAD ', 'align'=>'R', 'width'=>20, 'tipo'=>'');
    $arrCols[]=array('name'=>'valor_venta_aux', 'caption'=>'PRECIO ', 'align'=>'R', 'width'=>20, 'tipo'=>'');
    $arrCols[]=array('name'=>'total_aux', 'caption'=>'TOTAL ', 'align'=>'R', 'width'=>20, 'tipo'=>'');
    $arrCols=FitWidthCols($arrCols, A4_WIDTH_PORTRAIT, A4_WIDTH_LANDSCAPE);
    
    $pdf = new MYPDF("P", PDF_UNIT, PDF_PAGE_FORMAT, true, 'UTF-8', false); 
    $pdf->SetCreator(PDF_CREATOR);
    $pdf->setPrintHeader(true);
    $pdf->setPrintFooter(true);
    $pdf->SetDefaultMonospacedFont(PDF_FONT_MONOSPACED);
    $pdf->SetMargins($arrMarginOC['left'], $arrMarginOC['top'], $arrMarginOC['right']);
    $pdf->SetHeaderMargin(0);
    $pdf->SetFooterMargin(0);
    $pdf->SetAutoPageBreak(TRUE, $arrMarginOC['bottom']);
    $pdf->setImageScale(PDF_IMAGE_SCALE_RATIO); 
    $pdf->setLanguageArray($l); 
    $pdf->SetTitle('ORDEN DE COMPRA '.intval($rowOrden['correlativo']).' / '.$rowEmpresa['abreviatura']);
    $pdf->AddPage();
    $pdf->SetFillColor(240);
    $pdf->SetFont($vFontFamily, '', $fsData);

    $wPage=getPageWidth($pdf);
    $hPage=getPageHeight($pdf);
    $hRowDet=$hRowData; $hNow=0;
    if($rowOrden){
        ShowHead();
        ShowHeadOrden();
        ShowDetalleHead();

        $pdf->SetFont($vFontFamily, '', $fsData);

        $vContador=0;  $vContadorByPage=0;
        foreach($arrData as $iIndice=>$rowData){
            $vContador++; $vContadorByPage++;
            PrintRow($pdf, $arrCols, $rowData, $iIndice, $hRowDet, false, $vBorderData);
            $pdf->Ln($hRowDet);
            $hNow+=$hRowDet;
            if($vContador<count($arrData)){
                if(($hNow+$hRowDet)>$hPage){
                    $pdf->AddPage();
                    $hNow=0; $vContadorByPage=0;
                    ShowHead();
                    ShowHeadOrden();
                }
            }
        }
        
        if($hNow+ShowDetalleFoot('height')>$hPage){
            $pdf->AddPage();
            $hNow=0; $vContadorByPage=0;
            ShowHead();
            ShowHeadOrden();
        }
        ShowDetalleFoot();
        
        $hAux=$hPage-($hNow+ShowFoot('height')+ShowFootNota('height'))-3;
        if($hAux<0){
            $hAux=$hPage-($hNow+ShowFoot('height'));
        }
        if($hAux>0){
            $pdf->Ln($hAux);
            $hNow+=$hAux;
        }
        
        if($hNow+ShowFoot('height')>$hPage){
            $pdf->AddPage();
            $hNow=0; $vContadorByPage=0;
            ShowHead();
            ShowHeadOrden();
        }
        ShowFoot();
        
        if($hNow+ShowFootNota('height')<=$hPage){
            ShowFootNota();
        }
    }
    $pdf->Output('ORDEN-COMPRA-'.intval($rowOrden['correlativo']).'-'.$rowEmpresa['ruc'].'.pdf', 'I');
    ?>