<?
    header("Cache-Control: no-store, no-cache, must-revalidate"); 
    header("Pragma: no-cache");

    require_once("../../config.php");
    require_once(INTERFAZ."/seguridad.php");
    require_once(LOGICA."/Acceso.php");
    require_once(HERRAMIENTAS_PHP."/pdf.php");
    require_once(HERRAMIENTAS_PHP."/tcpdf/config/lang/eng.php");
    require_once(HERRAMIENTAS_PHP."/tcpdf/tcpdf.php");
    require_once(HERRAMIENTAS_PHP."/FunctionsPDF.php");

    class MYPDF extends TCPDF {	
        public $pTitulo;
        public $pSubTitulo;
        public $pDescripcion;
        public $rowWidth;
        public $arrZonas;
        public $pUsuario;

        public function Header() {
            $wAux=getPageWidth($this);
            $this->SetFillColor(240);
            $hAux=6; $this->Cell(0, $hAux, ""); $this->Ln($hAux);
            $hAux=7; PrintCell($this, $this->pTitulo, $wAux, $hAux, 10, 1, "C", true, 'B'); $this->Ln($hAux);
            $hAux=7; PrintCell($this, $this->pSubTitulo, ($wAux/2), $hAux, 10, 1, "L", false, 'B');
            $hAux=7; PrintCell($this, $this->pDescripcion, ($wAux/2), $hAux, 10, 1, "R", false, 'B'); $this->Ln($hAux);
            
            $this->SetFont('helvetica', 'B', 8);
            $hAux=5; $vColsAux=4;
            $vX=$this->getX();
            $vY=$this->getY();
            PrintCell($this, "N°", $this->rowWidth['orden'], $hAux*$vColsAux, 8, 1, 'C', true, "B");
            PrintCell($this, " PRODUCTO", $this->rowWidth['producto'], $hAux*$vColsAux, 8, 1, 'L', true, "B");
            foreach($this->arrZonas as $iZon=>$rowZon){
                $vValor=$rowZon['abreviatura'];
                PrintCell($this, $vValor, $this->rowWidth['importe']*count($rowZon['oAlmacen']), $hAux, 8, 1, 'C', true, "B");
            }
            PrintCell($this, "CANTIDAD", $this->rowWidth['total'], $hAux*$vColsAux, 8, 1, 'C', true, "B");
            PrintCell($this, "TOTAL ", $this->rowWidth['total'], $hAux*$vColsAux, 8, 1, 'R', true, "B");
            
            $vColsAux=3;
            $this->SetXY($vX+$this->rowWidth['orden']+$this->rowWidth['producto'], $vY+$hAux);
            foreach($this->arrZonas as $iZon=>$rowZon){
                foreach($rowZon['oAlmacen'] as $iAlm=>$rowAlm){
                    $vValor=$rowAlm['abreviatura'];
                    RotateText($this->rowWidth['importe'], $hAux*$vColsAux, $vValor, 8, -90, 1, "C", true, 'B');
                }
            }
        }
        public function Footer(){
            $this->SetY(-15);
            $this->SetFont('helvetica', 'I', 7);
            $this->Cell(0,10, date('d/m/Y h:i:s a')."   USUARIO: ".$this->pUsuario, "T", 0, 'L');
            $this->Cell(0,10,'Pagina '.$this->PageNo().'/'.$this->getAliasNbPages(),0,0,'R');
        }
    }

    //BEGIN OBTENIENDO VALORES
    ob_end_clean();
    $array=$_GET;
    $vEmpresaId=intval($array['empresaid']);
    $vZonaId=intval($array['zonaid']);
    $vAlmacenId=intval($array['almacenid']);
    $vDesde=trim($array['desde']); if(trim($vDesde)!='')$vDesde=CDate($array['desde']);
    $vHasta=trim($array['hasta']); if(trim($vHasta)!='')$vHasta=CDate($array['hasta']);
    $vCondicion=trim($array['condicion']);
    $vPersonaId=intval($array['presonaid']);

    $oE=new Acceso_clsEmpresa();
    $oZ=new Acceso_clsZona();
    $oA=new Acceso_clsPermisos_Almacen();
    $oR=new Acceso_Inventarios_clsReportes();

    $rowEmpresa=$oE->getROW($vEmpresaId);
    $vZonaNombre="TODAS LAS ZONAS";
    if($vZonaId>0){
        $rowZona=$oZ->getROW($vZonaId);
        $vZonaNombre=$rowZona['nombre'];
    }

    $vDescFechas="";
    if($vDesde!='' || $vHasta!=''){
        if($vDesde!='' && $vHasta!=''){
            $vDescFechas="ENTRE EL ".FormatDate($vDesde)." AL ".FormatDate($vHasta);
        }else{
            if($vDesde!='') $vDescFechas="DESDE EL ".FormatDate($vDesde);
            else $vDescFechas="HASTA EL ".FormatDate($vHasta);
        }
    }
    
    $rsZon=$oA->LeerZonas($vEmpresaId, $sessCodigo, 0, $vZonaId);
    $rsAlm=$oA->LeerAlmacenes($vEmpresaId, $sessCodigo, 0, $vZonaId);
    $rsPro=$oR->ProductosMasVendidos($vEmpresaId, $vZonaId, $vAlmacenId, $vTipoDocumentoId, $vCondicion, $vPersonaId, $vDesde, $vHasta);
    $rsRpt=$oR->ProductosMasVendidosDetalle($vEmpresaId, $vZonaId, $vAlmacenId, $vTipoDocumentoId, $vCondicion, $vPersonaId, $vDesde, $vHasta);

    $arrZon=array(); if($rsZon) $arrZon=$rsZon->fetchAll(PDO::FETCH_ASSOC);
    $arrAlm=array(); if($rsAlm) $arrAlm=$rsAlm->fetchAll(PDO::FETCH_ASSOC);
    $arrPro=array(); if($rsPro) $arrPro=$rsPro->fetchAll(PDO::FETCH_ASSOC);
    $arrAux=array(); if($rsRpt) $arrAux=$rsRpt->fetchAll(PDO::FETCH_ASSOC);

    $arrAlmAux=array(); foreach($arrAlm as $iAlm=>$rowAlm){ $arrAlmAux[$rowAlm['zonaid']][]=$rowAlm; }
    foreach($arrZon as $iZon=>$rowZon){
        $arrZon[$iZon]['oAlmacen']=(isset($arrAlmAux[$rowZon['zonaid']])?$arrAlmAux[$rowZon['zonaid']]:array());
    }
    
    $arrData=array();
    foreach($arrAux as $i=>$row){
        $arrData[$row['productoid']][$row['almacenid']]=array("cantidad"=>doubleval($row['cantidad']), "total"=>doubleval($row['total']));
    }

    //BEGIN PDF
    $pdf = new MYPDF("P", PDF_UNIT, PDF_PAGE_FORMAT, true, 'UTF-8', false); 
    $pdf->SetCreator(PDF_CREATOR);
    $pdf->setPrintHeader(true);
    $pdf->setPrintFooter(true);
    $pdf->SetDefaultMonospacedFont(PDF_FONT_MONOSPACED);
    $pdf->SetMargins(5, 40, 5);
    $pdf->SetHeaderMargin(0);
    $pdf->SetFooterMargin(0);
    $pdf->SetAutoPageBreak(true, 15);
    $pdf->setImageScale(PDF_IMAGE_SCALE_RATIO); 
    $pdf->setLanguageArray($l); 
    $pdf->SetTitle('PRODUCTOS MAS VENDIDOS'.(trim($vDescFechas)!=''?' '.$vDescFechas:''));
    $pdf->pTitulo='PRODUCTOS MAS VENDIDOS';
    $pdf->pSubTitulo=" ".$rowEmpresa['nombre'].' / '.$vZonaNombre;
    $pdf->pDescripcion=$vDescFechas." ";
    $pdf->arrZonas=$arrZon;

    $wPage=getPageWidth($pdf);
    $hPage=getPageHeight($pdf);

    $wOrd=6; $wPro=70; $wTot=20; $wColData=10;
    $wData=$wPage-($wTot*2)-$wOrd-$wPro;
    
    $wColDataAux=($wData/count($arrAlm));
    if($wColDataAux>$wColData){//SOBRA
        $wPro=$wPage-($wTot*2)-$wOrd-(count($arrAlm)*$wColData);
    }else{
        $pdf->setPageOrientation("L");
        $wPage=getPageWidth($pdf);
        $wData=$wPage-($wTot*2)-$wOrd-$wPro;
        $wColDataAux=($wData/count($arrAlm));
        if($wColDataAux>$wColData){//SOBRA
            $wPro=$wPage-($wTot*2)-$wOrd-(count($arrAlm)*$wColData);
        }else{
            $wColData=$wColDataAux;
        }
    }

    $rowWidth=array("orden"=>$wOrd, "producto"=>$wPro, "importe"=>$wColData, "total"=>$wTot);
    $pdf->rowWidth=$rowWidth;

    $fsSize=8; $hRowDet=5;
    $hNow=0;
    $pdf->SetFont('helvetica', '', $fsSize);
    
    $pdf->SetFillColor(240);
    
    $pdf->AddPage();

    $vContador=0;
    $pdf->SetFillColor(240);
    $arrTotales=array();
    if(count($arrPro)>0){
        foreach($arrPro as $ic=>$rowPro){
            $vProductoIdAux=intval($rowPro['productoid']);
            $vContador++;

            $pdf->SetFont('helvetica', '', $fsSize);

            PrintCell($pdf, $vContador, $rowWidth['orden'], $hRowDet, $fsSize, 1, 'C');
            PrintCell($pdf, $rowPro['producto'], $rowWidth['producto'], $hRowDet, $fsSize, 1, 'L');

            $vTotRowCant=0; $vTotRowTota=0;
            foreach($arrZon as $iZon=>$rowZon){
                foreach($rowZon['oAlmacen'] as $iAlm=>$rowAlm){
                    $vValor="";
                    if(isset($arrData[$vProductoIdAux][$rowAlm['almacenid']])){
                        $vCantAux=doubleval($arrData[$vProductoIdAux][$rowAlm['almacenid']]['cantidad']);
                        $vTotaAux=doubleval($arrData[$vProductoIdAux][$rowAlm['almacenid']]['total']);
                        $vTotRowCant+=doubleval($vCantAux);
                        $vTotRowTota+=$vTotaAux;

                        $vValor=number_format($vCantAux,0);
                        $arrTotales[$rowAlm['almacenid']]+=$vCantAux;
                        $arrTotales['total']+=$vTotRowTota;
                    }
                    PrintCell($pdf, $vValor, $rowWidth['importe'], $hRowDet, $fsSize, 1, 'C');
                }
            }
            
            $pdf->SetFont('helvetica', 'B', 8);
            $vValor=($vTotRowCant==0?'':number_format($vTotRowCant, 0));
            PrintCell($pdf, $vValor, $rowWidth['total'], $hRowDet, $fsSize, 1, 'C', true, "B");
            
            $vValor=($vTotRowTota==0?'':number_format($vTotRowTota, 2));
            PrintCell($pdf, $vValor, $rowWidth['total'], $hRowDet, $fsSize, 1, 'R', true, "B");
            
            $pdf->Ln($hRowDet);
        }
        /*
        //BEGIN TOTALES
        $pdf->SetFont('helvetica', 'B', 8);        
        PrintCell($pdf, "TOTALES ", $rowWidth['orden']+$rowWidth['producto'], $hRowDet, $fsSize, 1, 'R', true, "B");
        $vTotRowCant=0;
        foreach($arrZon as $iZon=>$rowZon){
            foreach($rowZon['oAlmacen'] as $iAlm=>$rowAlm){
                $vValor="";
                if(isset($arrTotales[$rowAlm['almacenid']])){
                    $vCantAux=doubleval($arrTotales[$rowAlm['almacenid']]);
                    $vValor=number_format($vCantAux,0);
                    $vTotRowCant+=$vCantAux;
                }
                PrintCell($pdf, $vValor, $rowWidth['importe'], $hRowDet, $fsSize, 1, 'C', true, "B");
            }
        }
        $vValor=($vTotRowCant==0?'':number_format($vTotRowCant, 0));
        PrintCell($pdf, $vValor, $rowWidth['total'], $hRowDet, $fsSize, 1, 'C', true, "B");
        $vTotalAux=doubleval($arrTotales['total']);
        $vValor=($vTotalAux==0?'':number_format($vTotalAux, 2));
        PrintCell($pdf, $vValor, $rowWidth['total'], $hRowDet, $fsSize, 1, 'R', true, "B");
        //END TOTALES
        */
    }
    
    $pdf->Output('PRODUCTOS-MAS-VENDIDOS.pdf', 'I');
    ?>
