<?
    header("Cache-Control: no-store, no-cache, must-revalidate"); 
    header("Pragma: no-cache");

    require_once("../../config.php");
    require_once(INTERFAZ."/seguridad.php");
    require_once(LOGICA."/Acceso.php");
    require_once(HERRAMIENTAS_PHP."/pdf.php");
    require_once(HERRAMIENTAS_PHP."/tcpdf/config/lang/eng.php");
    require_once(HERRAMIENTAS_PHP."/tcpdf/tcpdf.php");
    require_once(HERRAMIENTAS_PHP."/FunctionsPDF.php");
    require_once(HERRAMIENTAS_PHP."/Venta.php");

    class MYPDF extends TCPDF{
        public function Header(){ }
        public function Footer(){ }
    }
    
    //BEGIN OBTENIENDO VALORES
    $array=$_GET;
    $vVentaId=intval($array["ventaid"]);
    //END OBTENIENDO VALORES

    //BEGIN DATA
    $oV=new Acceso_clsVenta();
    $oEmp=new Acceso_clsEmpresa();
    $oConfig=new Acceso_clsConfig();

    $rowVenta=$oV->getPrintRow($vVentaId);
    $vEmpresaId=intval($rowVenta['empresaid']);
    $rowEmpresa=$oEmp->getROW($vEmpresaId);
    $rsItems=$oV->getPrintDetalle($vVentaId);

    $arrData=array(); if($rsItems) $arrData=$rsItems->fetchAll(PDO::FETCH_ASSOC);
    
    foreach($arrData as $iIndice=>$rowData){
        $arrData[$iIndice]['cantidad_aux']=number_format($rowData['cantidad'], 2, ".", ",");
        $arrData[$iIndice]['precio_aux']=number_format($rowData['precio'], 2, ".", ",");
        $arrData[$iIndice]['descuento_aux']=number_format($rowData['descuento'], 2, ".", ",");
        $arrData[$iIndice]['total_aux']=number_format($rowData['total'], 2, ".", ",");
    }
    //END DATA

    
    //BEGIN CONFIGRACION DEL FORMATO
    $rsConfig=$oConfig->Query("reportes", "inventarios-venta", '');
    $arrConfigAux=array(); if($rsConfig) $arrConfigAux=$rsConfig->fetchAll(PDO::FETCH_ASSOC);
    $arrConfigCols=array(); foreach($arrConfigAux as $ia=>$row){ $arrConfigCols[$row['configvars_name']]=$row['valor']; }
    $vFontFamily=(trim($arrConfigCols['font-family'])==''?'Helvetica':trim($arrConfigCols['font-family']));
    $fsData=(doubleval($arrConfigCols['font-size-data'])<=0?8:doubleval($arrConfigCols['font-size-data']));
    $hRowData=(doubleval($arrConfigCols['height-row-data'])<=0?5:doubleval($arrConfigCols['height-row-data']));
    $vBorderData=(intval($arrConfigCols['border-data'])==1?1:0);
    $swPintarData=(intval($arrConfigCols['pintar-data'])==1);
    //END CONFIGRACION DEL FORMATO

    $arrCols[]=array('name'=>'', 'caption'=>'N°', 'align'=>'C', 'width'=>7, 'tipo'=>'NO');
    $arrCols[]=array('name'=>'productoid', 'caption'=>'CODIGO', 'align'=>'C', 'width'=>20, 'tipo'=>'');
    $arrCols[]=array('name'=>'producto', 'caption'=>' DESCRIPCION', 'align'=>'L', 'width'=>70, 'tipo'=>'', 'fitwidth'=>100);
    $arrCols[]=array('name'=>'cantidad_aux', 'caption'=>'CANTIDAD ', 'align'=>'R', 'width'=>20, 'tipo'=>'');
    $arrCols[]=array('name'=>'precio_aux', 'caption'=>'PRECIO ', 'align'=>'R', 'width'=>20, 'tipo'=>'');
    $arrCols[]=array('name'=>'descuento_aux', 'caption'=>'DSCTO ', 'align'=>'R', 'width'=>20, 'tipo'=>'');
    $arrCols[]=array('name'=>'total_aux', 'caption'=>'TOTAL ', 'align'=>'R', 'width'=>20, 'tipo'=>'');
    $arrCols=FitWidthCols($arrCols, A4_WIDTH_PORTRAIT, A4_WIDTH_LANDSCAPE);
    
    $pdf = new MYPDF("P", PDF_UNIT, PDF_PAGE_FORMAT, true, 'UTF-8', false); 
    $pdf->SetCreator(PDF_CREATOR);
    $pdf->setPrintHeader(true);
    $pdf->setPrintFooter(true);
    $pdf->SetDefaultMonospacedFont(PDF_FONT_MONOSPACED);
    $pdf->SetMargins($arrMarginOC['left'], $arrMarginOC['top'], $arrMarginOC['right']);
    $pdf->SetHeaderMargin(0);
    $pdf->SetFooterMargin(0);
    $pdf->SetAutoPageBreak(TRUE, $arrMarginOC['bottom']);
    $pdf->setImageScale(PDF_IMAGE_SCALE_RATIO); 
    $pdf->setLanguageArray($l); 
    $pdf->SetTitle('VENTA '.trim($rowVenta['tipodocumento_abreviatura'])." ".trim($rowVenta['numero']).' / '.$rowEmpresa['abreviatura']);
    $pdf->AddPage();
    $pdf->SetFillColor(240);
    $pdf->SetFont($vFontFamily, '', $fsData);

    $wPage=getPageWidth($pdf);
    $hPage=getPageHeight($pdf);
    $hRowDet=$hRowData; $hNow=0;
    if($rowVenta){
        ShowHead();
        ShowHeadVenta();
        ShowDetalleHead();

        $pdf->SetFont($vFontFamily, '', $fsData);

        $vContador=0;  $vContadorByPage=0;
        foreach($arrData as $iIndice=>$rowData){
            $vContador++; $vContadorByPage++;
            PrintRow($pdf, $arrCols, $rowData, $iIndice, $hRowDet, false, $vBorderData);
            $pdf->Ln($hRowDet);
            $hNow+=$hRowDet;
            if($vContador<count($arrData)){
                if(($hNow+$hRowDet)>$hPage){
                    $pdf->AddPage();
                    $hNow=0; $vContadorByPage=0;
                    ShowHead();
                    ShowHeadVenta();
                    ShowDetalleHead();
                }
            }
        }
        
        if($hNow+ShowFoot('height')>$hPage){
            $pdf->AddPage();
            $hNow=0; $vContadorByPage=0;
            ShowHead();
            ShowHeadVenta();
            ShowDetalleHead();
        }
        ShowFoot();
    }
    $pdf->Output('VENTA-'.trim($rowVenta['tipodocumento_abreviatura'])."-".trim($rowVenta['numero']).'-'.$rowEmpresa['ruc'].'.pdf', 'I');
    ?>