<?
    header("Cache-Control: no-store, no-cache, must-revalidate"); 
    header("Pragma: no-cache");

    require_once("../../config.php");
    require_once(INTERFAZ."/seguridad.php");
    require_once(LOGICA."/Acceso.php");
    require_once(HERRAMIENTAS_PHP."/pdf.php");
    require_once(HERRAMIENTAS_PHP."/tcpdf/config/lang/eng.php");
    require_once(HERRAMIENTAS_PHP."/tcpdf/tcpdf.php");
    require_once(HERRAMIENTAS_PHP."/FunctionsPDF.php");

    function ShowProducto(){
        global $pdf, $vFontFamily, $fsSize, $hRowPro, $hNow, $rowPro, $wPage, $rowWidth;
        $vValor=$rowPro['nombre'];
        PrintCell($pdf, $vValor, $wPage, $hRowPro, $fsSize, 1, "L", true, 'B', $vFontFamily);
        $pdf->Ln($hRowPro);
        $hNow+=$hRowPro;
    }
    
    class MYPDF extends TCPDF {	
        public $rowWidth;
        public $pUsuario;
        public $pTitulo;
        public $pSubTitulo;
        public $pDescripcion1;
        public $pDescripcion2;
        
        public function Header() {
            $wAux=getPageWidth($this);
            $this->SetFillColor(240);
            $hAux=11; $this->Cell(0, $hAux, ""); $this->Ln($hAux);
            $hAux=7; PrintCell($this, $this->pTitulo, ($wAux/2), $hAux, 10, 1, "L", true, 'B');
            $hAux=7; PrintCell($this, $this->pSubTitulo, ($wAux/2), $hAux, 10, 1, "R", true, 'B'); $this->Ln($hAux);
            $hAux=7; PrintCell($this, $this->pDescripcion1, ($wAux/2), $hAux, 10, 1, "L", false, 'B');
            $hAux=7; PrintCell($this, $this->pDescripcion2, ($wAux/2), $hAux, 10, 1, "R", false, 'B'); $this->Ln($hAux);
            
            $this->SetFont('helvetica', 'B', 8);
            $hAux=5; $wAux=$this->rowWidth['detalle']+$this->rowWidth['orden']+$this->rowWidth['fecha'];
            PrintCell($this, " CATEGORIA / DETALLES", $wAux, $hAux, 8, 1, 'L', true, "B");
            PrintCell($this, " ALM", $this->rowWidth['almacen'], $hAux, 8, 1, 'L', true, "B");
            PrintCell($this, " DNI/RUC", $this->rowWidth['ruc'], $hAux, 8, 1, 'L', true, "B");
            PrintCell($this, " ", $this->rowWidth['moneda'], $hAux, 8, 1, 'L', true, "B");
            PrintCell($this, "CANT ", $this->rowWidth['cantidad'], $hAux, 8, 1, 'R', true, "B");
            PrintCell($this, "PRECIO ", $this->rowWidth['precio'], $hAux, 8, 1, 'R', true, "B");
            PrintCell($this, "TOTAL ", $this->rowWidth['total'], $hAux, 8, 1, 'R', true, "B");
        }

        public function Footer(){
            $this->SetY(-15);
            $this->SetFont('helvetica', 'I', 7);
            $this->Cell(0,10, date('d/m/Y h:i:s a')."   USUARIO: ".$this->pUsuario, "T", 0, 'L');
            $this->Cell(0,10,'Pagina '.$this->PageNo().'/'.$this->getAliasNbPages(),0,0,'R');
        }
    }
    
    //BEGIN OBTENIENDO VALORES
    $array=$_GET;
    $vEmpresaId=intval($array['empresaid']);
    $vZonaId=intval($array['zonaid']);
    $vAlmacenId=intval($array['almacenid']);
    $vProductoId=intval($array['productoid']);
    $vDesde=trim($array['desde']); if(trim($vDesde)!='')$vDesde=CDate($array['desde']);
    $vHasta=trim($array['hasta']); if(trim($vHasta)!='')$vHasta=CDate($array['hasta']);
    //END OBTENIENDO VALORES

    $oE=new Acceso_clsEmpresa();
    $oZ=new Acceso_clsZona();
    $oA=new Acceso_clsAlmacen();
    $oR=new Acceso_Inventarios_clsReportes();

    $rowEmpresa=$oE->getROW($vEmpresaId);
    $vZonaNombre="TODAS LAS ZONAS";
    if($vZonaId>0){
        $rowZona=$oZ->getROW($vZonaId);
        $vZonaNombre=$rowZona['nombre'];
    }
    $vAlmacenNombre="TODAS LOS ALMACENES";
    if($vAlmacenId>0){
        $rowAlmacen=$oA->getROW($vAlmacenId);
        $vAlmacenNombre=$rowAlmacen['nombre'];
    }
    $vDescFechas="";
    if($vDesde!='' || $vHasta!=''){
        if($vDesde!='' && $vHasta!=''){
            $vDescFechas="ENTRE EL ".FormatDate($vDesde)." AL ".FormatDate($vHasta);
        }else{
            if($vDesde!='') $vDescFechas="DESDE EL ".FormatDate($vDesde);
            else $vDescFechas="HASTA EL ".FormatDate($vHasta);
        }
    }
    
    $vFileName= strtoupper(FileName($vZonaNombre."-".$vAlmacenNombre."-".$rowEmpresa['ruc']));

    //BEGIN LEER DATA
    $rsRpt=$oR->VentasDetalladasProducto($vEmpresaId, $vZonaId, $vAlmacenId, $vDesde, $vHasta, $vProductoId);

    $arrData=array(); if($rsRpt) $arrData=$rsRpt->fetchAll(PDO::FETCH_ASSOC);
    
    $arrPro=array();
    foreach($arrData as $iData=>$row){
        $vIDS="IDS-".$row['productoid'];
        $swExiste=(isset($arrPro[$vIDS]));
        if(!$swExiste) $arrPro[$vIDS]=array("productoid"=>$row['productoid'], "nombre"=>$row['producto']);
        $arrPro[$vIDS]['oData'][]=$row;
    }
    //END LEER DATA
    
    $pdf = new MYPDF("P", PDF_UNIT, PDF_PAGE_FORMAT, true, 'UTF-8', false); 
    $pdf->SetCreator(PDF_CREATOR);
    $pdf->setPrintHeader(true);
    $pdf->setPrintFooter(true);
    $pdf->SetDefaultMonospacedFont(PDF_FONT_MONOSPACED);
    $pdf->SetMargins(10, 32, 10);
    $pdf->SetHeaderMargin(0);
    $pdf->SetFooterMargin(0);
    $pdf->SetAutoPageBreak(true, 15);
    $pdf->setImageScale(PDF_IMAGE_SCALE_RATIO); 
    $pdf->setLanguageArray($l); 
    $pdf->pUsuario=$sessUsuario;
    $pdf->rowWidth=$rowWidth;
    $pdf->pTitulo=' VENTAS DETALLADAS POR PRODUCTO ';
    $pdf->pSubTitulo=$rowEmpresa['nombre']." ";
    $pdf->pDescripcion1=" ".$vZonaNombre.' / '.$vAlmacenNombre;
    $pdf->pDescripcion2=$vDescFechas." ";
    $pdf->SetTitle('VENTAS DETALLADAS POR PRODUCTO / '.$rowEmpresa['ruc']." / ".$vZonaNombre.' / '.$vAlmacenNombre);

    $fsSize=8; $hRowPro=5; $hRowDet=4;
    $hNow=0;
    $pdf->SetFont('helvetica', '', $fsSize);

    //BEGIN CALCULAMOS EL ANCHO DE COLUMNAS
    $wPage=getPageWidth($pdf);
    $hPage=getPageHeight($pdf);

    $wOrden=10; $wFecha=18; $wDetalle=30; $wAlmacen=15; $wMoneda=10; $wRUC=20; $wCantidad=20; $wPrecio=20; $wTotal=20;
    $wDetalle=$wPage-$wRUC-$wOrden-$wFecha-$wMoneda-$wCantidad-$wPrecio-$wTotal-$wAlmacen;
    //END CALCULAMOS EL ANCHO DE COLUMNAS

    $rowWidth=array("orden"=>$wOrden, "fecha"=>$wFecha, "detalle"=>$wDetalle, "almacen"=>$wAlmacen, "ruc"=>$wRUC, "moneda"=>$wMoneda, "cantidad"=>$wCantidad, "precio"=>$wPrecio, "total"=>$wTotal);
    $pdf->rowWidth=$rowWidth;

    $pdf->AddPage();
    
    $vContador=0;
    $pdf->SetFillColor(240);
    $arrTotales=array();
    if(count($arrPro)>0){
        foreach($arrPro as $ic=>$rowPro){
            $vContador++;
            
            if($hNow+($hRowPro+$hRowDet)>$hPage){
                $pdf->AddPage();
                $hNow=0;
            }
            $pdf->SetFont('helvetica', 'B', $fsSize);

            ShowProducto();
            
            $vProductoCantidad=0;
            $vProductoTotal=0;
            foreach($rowPro['oData'] as $iData=>$rowData){
                $vProductoCantidad+=doubleval($rowData['cantidad']);
                $vProductoTotal+=doubleval($rowData['total']);

                PrintCell($pdf, ($iData+1), $wOrden, $hRowDet, $fsSize, 0, 'R');
                $vValor=FormatDate($rowData['fecha']);
                PrintCell($pdf, $vValor, $wFecha, $hRowDet, $fsSize, 0, "C");
                $vValor=$rowData['numero_detalle'];
                PrintCell($pdf, $vValor, $wDetalle, $hRowDet, $fsSize, 0, "L");
                $vValor=$rowData['almacen_abreviatura'];
                PrintCell($pdf, $vValor, $wAlmacen, $hRowDet, $fsSize, 0, "L");
                $vValor=$rowData['cliente_nrodoc'];
                PrintCell($pdf, $vValor, $wRUC, $hRowDet, $fsSize, 0, "L");
                $vValor=$rowData['simbolo_moneda'];
                PrintCell($pdf, $vValor, $wMoneda, $hRowDet, $fsSize, 0, "L");

                $vValor=number_format(doubleval($rowData['cantidad']),2);
                PrintCell($pdf, $vValor, $wCantidad, $hRowDet, $fsSize, 0, "R");
                $vValor=number_format(doubleval($rowData['precio']),2);
                PrintCell($pdf, $vValor, $wPrecio, $hRowDet, $fsSize, 0, "R");
                $vValor=number_format(doubleval($rowData['total']),2);
                PrintCell($pdf, $vValor, $wTotal, $hRowDet, $fsSize, 0, "R");

                $hNow+=$hRowDet;
                if(($iKar+1)<count($rowPro['oData'])){
                    if(($hNow+$hRowDet)>$hPage){
                        $pdf->AddPage();
                        $hNow=0;
                        ShowProducto();
                    }else $pdf->Ln($hRowDet);
                }else $pdf->Ln($hRowDet);
            }
            
            if(count($rowPro['oData'])>1){
                if(($hNow+$hRowDet)>$hPage){
                    $pdf->AddPage();
                    $hNow=0;
                    ShowProducto();
                }
                $vX=$pdf->GetX();
                PrintCell($pdf, "", $wPage, $hRowDet, $fsSize, "T", "C");
                $pdf->SetX($vX+$wOrden+$wFecha+$wDetalle+$wAlmacen+$wRUC+$wMoneda);
                PrintCell($pdf, number_format($vProductoCantidad, 2), $wCantidad, $hRowDet, $fsSize, 0, "R", false, "B");
                PrintCell($pdf, "", $wPrecio, $hRowDet, $fsSize, 0, "C");
                PrintCell($pdf, number_format($vProductoTotal, 2), $wTotal, $hRowDet, $fsSize, 0, "R", false, "B");
                if(($hNow+($hRowDet*2))<$hPage){
                    $pdf->Ln($hRowDet*2);
                    $hNow+=($hRowDet*2);
                }elseif(($hNow+$hRowDet)<$hPage){
                    $pdf->Ln($hRowDet);
                    $hNow+=$hRowDet;
                }
            }elseif(count($rowPro['oData'])==1){
                if(($hNow+$hRowDet)<$hPage){
                    $pdf->Ln($hRowDet);
                    $hNow+=$hRowDet;
                }
            }
        }

    }
    
    $pdf->Output("PRODUCTOS-MASVENDIDOS-".$vFileName.".pdf", 'I');
    ?>