<?
    header("Cache-Control: no-store, no-cache, must-revalidate"); 
    header("Pragma: no-cache");

    require_once("../../config.php");
    require_once(INTERFAZ."/seguridad.php");
    require_once(LOGICA."/Acceso.php");
    require_once(HERRAMIENTAS_PHP."/pdf.php");
    require_once(HERRAMIENTAS_PHP."/tcpdf/config/lang/eng.php");
    require_once(HERRAMIENTAS_PHP."/tcpdf/tcpdf.php");
    require_once(HERRAMIENTAS_PHP."/FunctionsPDF.php");

    function ShowHead(){
        global $pdf;
        global $wOrden, $wCellAlm, $wCellData, $wTotales, $esUltGru, $hRowDet;
        global $wPage, $hPage, $hNow, $rowGruCol;

        //LINEA 2
        $hGrid=$hRowDet;
        $vX=$pdf->getX();
        PrintCell($pdf, "N°", $wOrden, $hGrid*2, 8, 1, 'C', true, "B");
        PrintCell($pdf, " ALMACEN", $wCellAlm, $hGrid*2, 8, 1, 'L', true, "B");
        foreach ($rowGruCol['oMeses'] as $iMes=>$rowMes){
            $vColumnas=count($rowMes['oDias']);
            $wAux=$vColumnas*$wCellData;
            $vValor=strtoupper($rowMes['nombre'])." - ".intval($rowMes['ano']);
            PrintCell($pdf, $vValor, $wAux, $hGrid, 8, 1, 'C', true, "B");
        }
        if($esUltGru){
            PrintCell($pdf, "TOTAL", $wTotales, $hGrid*2, 8, 1, 'R', true, "B");
        }
        $pdf->Ln($hGrid);
        
        $pdf->SetX($vX+$wOrden+$wCellAlm);
        foreach ($rowGruCol['oDias'] as $iDia=>$rowDia){
            $vValor=$rowDia['abreviatura'].", ".$rowDia['day'];
            PrintCell($pdf, $vValor, $wCellData, $hGrid, 8, 1, 'C', true, "B");
        }
        $pdf->Ln($hGrid);
        
        $hNow+=$hGrid*2;
    }
    
    class MYPDF extends TCPDF {	
        public $rowWidth;
        public $arrColses;
        public $pUsuario;
        public $pTitulo;
        public $pSubTitulo;
        public $pDescripcion;
        public function Header() {
            $wAux=getPageWidth($this);
            $this->SetFillColor(240);
            $hAux=11; $this->Cell(0, $hAux, ""); $this->Ln($hAux);
            $hAux=7; PrintCell($this, $this->pTitulo, $wAux, $hAux, 10, 1, "C", true, 'B'); $this->Ln($hAux);
            $hAux=7; PrintCell($this, $this->pSubTitulo, $wAux, $hAux, 10, 1, "C", false, 'B'); $this->Ln($hAux);
        }

        public function Footer(){
            $this->SetY(-15);
            $this->SetFont('helvetica', 'I', 7);
            $this->Cell(0,10, date('d/m/Y h:i:s a')."   USUARIO: ".$this->pUsuario, "T", 0, 'L');
            $this->Cell(0,10,'Pagina '.$this->PageNo().'/'.$this->getAliasNbPages(),0,0,'R');
        }
    }
    
    ob_end_clean();
    //BEGIN OBTENIENDO VALORES
    $array=$_GET;
    $vEmpresaId=intval($array['empresaid']);
    $vTipo=intval($array['tipo']);
    $vZonaId=intval($array['zonaid']);
    $vDesde=CDate($array['desde']);
    $vHasta=CDate($array['hasta']);
    //END OBTENIENDO VALORES

    $oE=new Acceso_clsEmpresa();
    $oZ=new Acceso_clsZona();
    $oA=new Acceso_clsPermisos_Almacen();
    $oR=new Acceso_Inventarios_clsReportes();

    $rowEmpresa=$oE->getROW($vEmpresaId);
    $vZonaNombre="TODAS LAS ZONAS";
    if($vZonaId>0){
        $rowZona=$oZ->getROW($vZonaId);
        $vZonaNombre=$rowZona['nombre'];
    }

    $vTipoNombre="TODOS LOS TIPOS";
    if($vTipo>=0){
        $vTipoNombre=($vTipo==0?'MERCADERIA':'SERVICIOS');
    }
    
    //BEGIN LEER DATA
    $rsAlm=$oA->LeerAlmacenes($vEmpresaId, $sessCodigo, 0, $vZonaId);
    $rsRpt=$oR->VentasDiarias($vEmpresaId, $vTipo, $vZonaId, $vDesde, $vHasta);

    $arrAlm=array(); if($rsAlm) $arrAlm=$rsAlm->fetchAll(PDO::FETCH_ASSOC);
    $arrAux=array(); if($rsRpt) $arrAux=$rsRpt->fetchAll(PDO::FETCH_ASSOC);

    $arrData=array();
    foreach($arrAux as $i=>$row){
        $arrData[$row['almacenid']][$row['ano']][$row['mes']][$row['dia']]=doubleval($row['total']);
    }
    $arrCols= getDaysRange($vDesde, $vHasta);
    //END LEER DATA
    
    $pdf = new MYPDF("L", PDF_UNIT, PDF_PAGE_FORMAT, true, 'UTF-8', false); 
    $pdf->SetCreator(PDF_CREATOR);
    $pdf->setPrintHeader(true);
    $pdf->setPrintFooter(true);
    $pdf->SetDefaultMonospacedFont(PDF_FONT_MONOSPACED);
    $pdf->SetMargins(10, 25, 10);
    $pdf->SetHeaderMargin(0);
    $pdf->SetFooterMargin(0);
    $pdf->SetAutoPageBreak(true, 15);
    $pdf->setImageScale(PDF_IMAGE_SCALE_RATIO); 
    $pdf->setLanguageArray($l); 
    $pdf->pUsuario=$sessUsuario;
    $pdf->rowWidth=$rowWidth;
    $pdf->arrMeses=$arrCols;
    $pdf->pTitulo='VENTAS DIARIAS'.(trim($vTipoNombre)!=''?' / '.$vTipoNombre:'');
    $pdf->pSubTitulo=$rowEmpresa['nombre'].' / '.$vZonaNombre;
    $pdf->SetTitle('VENTAS DIARIAS / '.$rowEmpresa['nombre'].(trim($vTipoNombre)!=''?' / '.$vTipoNombre:''));

    $fsSize=8; $hRowDet=5;
    $hNow=0;
    $pdf->SetFont('helvetica', '', $fsSize);

    //BEGIN CALCULAMOS EL ANCHO DE COLUMNAS
    $wPage=getPageWidth($pdf);
    $hPage=getPageHeight($pdf);

    $wOrden=10; $wAlmacen=40; $wCol=15; $wTotales=20;
    $wData=($wPage-$wOrden-$wAlmacen);
    //END CALCULAMOS EL ANCHO DE COLUMNAS

    //BEGIN GRUPOS
    $arrGrupos=array(); $vIndice=0; $vColsAux=0;
    foreach($arrCols as $iMes=>$rowMes){
        foreach($rowMes['oDias'] as $iDia=>$rowDia){
            $vColsAux++;
            if($iMes==0 && $iDia=0){
                $arrGrupos[$vIndice]['oDias'][]=$rowDia;
                $arrGrupos[$vIndice]['columnas']++;
            }else{
                if(($wData/$vColsAux)>$wCol){
                    $arrGrupos[$vIndice]['oDias'][]=$rowDia;
                    $arrGrupos[$vIndice]['columnas']++;
                }else{
                    $vIndice++;
                    $arrGrupos[$vIndice]['oDias'][]=$rowDia;
                    $arrGrupos[$vIndice]['columnas']++;
                    $vColsAux=1;
                }
            }
        }
    }
    //END GRUPOS
    //BEGIN MESES DENTRO DEL GRUPO
    foreach($arrGrupos as $iGrupo=>$rowGrupo){
        $arrAux=array();
        foreach($rowGrupo['oDias'] as $iDia=>$rowDia){
            $vAnoAux=intval(FormatDate($rowDia['fecha'], "Y"));
            $vMesAux=intval(FormatDate($rowDia['fecha'], "m"));
            $arrAux[$vAnoAux][$vMesAux][]=$rowDia;
        }
        $arrMesesAux=array();
        foreach($arrAux as $iAno=>$vAnoArr){
            foreach($vAnoArr as $iMes=>$vMesArr){
                $arrMesesAux[]=array("ano"=>$iAno, "mesid"=>$iMes, "nombre"=> MonthName($iMes), "oDias"=>$vMesArr);
            }
        }
        $arrGrupos[$iGrupo]['oMeses']=$arrMesesAux;
    }
    //END MESES DENTRO DEL GRUPO

    $pdf->AddPage();
    
    $vContador=0;
    $pdf->SetFillColor(240);
    $arrTotales=array(); $arrTotAlm=array();
    if(count($arrAlm)>0){
        foreach($arrGrupos as $iGrupo=>$rowGruCol){
            $vCantCols=count($rowGruCol['oDias']);
            $esUltGru=($iGrupo==(count($arrGrupos)-1));
            
            $wData=($wPage-$wOrden-$wAlmacen);
            
            $wCellAlm=$wPage - $wOrden - $wTotales - ($vCantCols*$wCol)-($esUltGru?$wTotales:0);
            $wCellData=$wCol;
            
            if($wCellAlm<=$wAlmacen){
                $wCellAlm=$wAlmacen;
                $wCellData=(floor($wPage - $wOrden - $wAlmacen - ($esUltGru?$wTotales:0))/$vCantCols);
            }
            $wTotalCells=($wOrden+$wCellAlm+($vCantCols*$wCellData)+($esUltGru?$wTotales:0));
            if($wPage>$wTotalCells) $wCellAlm+=($wPage-$wTotalCells);
            
            if(($hNow+($hRowDet*3))>$hPage){
                $pdf->AddPage();
                $hNow=0;
            }
            ShowHead();
            $vContador=0;
            foreach($arrAlm as $ic=>$rowAlm){
                $vAlmacenIdAux=intval($rowAlm['almacenid']);
                $vContador++;

                $pdf->SetFont('helvetica', '', $fsSize);

                PrintCell($pdf, $vContador, $wOrden, $hRowDet, $fsSize, 1, 'C');
                PrintCell($pdf, $rowAlm['nombre'], $wCellAlm, $hRowDet, $fsSize, 1, 'L');

                foreach($rowGruCol['oDias'] as $ia=>$rowDia){
                    $vAnoAux=intval(FormatDate($rowDia['fecha'], "Y"));
                    $vMesAux=intval(FormatDate($rowDia['fecha'], "m"));
                    $vDiaAux=intval($rowDia['day']);
                    $vValor="";
                    if(isset($arrData[$vAlmacenIdAux][$vAnoAux][$vMesAux][$vDiaAux])){
                        $vImporteAux=doubleval($arrData[$vAlmacenIdAux][$vAnoAux][$vMesAux][$vDiaAux]);
                        $arrTotAlm[$vAlmacenIdAux]+=doubleval($vImporteAux);
                        $vValor=number_format($vImporteAux,2);
                        $arrTotales[$vAnoAux][$vMesAux][$vDiaAux]+=$vImporteAux;
                    }
                    PrintCell($pdf, $vValor, $wCellData, $hRowDet, $fsSize, 1, 'R');
                }
                if($esUltGru){
                    $pdf->SetFont('helvetica', 'B', 8);
                    $vTotalFila=doubleval($arrTotAlm[$vAlmacenIdAux]);
                    $vValor=($vTotalFila==0?'':number_format($vTotalFila, 2));
                    PrintCell($pdf, $vValor, $wTotales, $hRowDet, $fsSize, 1, 'R', true, "B");
                }
                
                $hNow+=$hRowDet;

                if(($hNow+$hRowDet)>$hPage){
                    if(count($arrAlm)>$vContador){
                        $pdf->AddPage();
                        $hNow=0;
                        ShowHead();
                    }
                }else{
                    $pdf->Ln($hRowDet);
                }
            }
            //BEGIN TOTALES
            if(($hNow+$hRowDet)>$hPage){
                $pdf->AddPage();
                $hNow=0;
                ShowHead();
            }
            $pdf->SetFont('helvetica', 'B', 8);        
            PrintCell($pdf, "TOTALES", $wOrden+$wCellAlm, $hRowDet, $fsSize, 1, 'L', true, "B");
            foreach($rowGruCol['oDias'] as $ia=>$rowDia){
                $vAnoAux=intval(FormatDate($rowDia['fecha'], "Y"));
                $vMesAux=intval(FormatDate($rowDia['fecha'], "m"));
                $vDiaAux=intval($rowDia['day']);
                $vValor="";
                if(isset($arrTotales[$vAnoAux][$vMesAux][$vDiaAux])){
                    $vImporteAux=doubleval($arrTotales[$vAnoAux][$vMesAux][$vDiaAux]);
                    $vValor=number_format($vImporteAux,2);
                    $arrTotAlm['all']+=$vImporteAux;
                }
                PrintCell($pdf, $vValor, $wCellData, $hRowDet, $fsSize, 1, 'R', true, "B");
            }
            if($esUltGru){
                $vTotalFila=doubleval($arrTotAlm['all']);
                $vValor=($vTotalFila==0?'':number_format($vTotalFila, 2));
                PrintCell($pdf, $vValor, $wTotales, $hRowDet, $fsSize, 1, 'R', true, "B");
            }
            $pdf->Ln($hRowDet);
            $hNow+=$hRowDet;
            
            if(($hNow+$hRowDet)<$hPage){ //MARGEN
                if(!$esUltGru){
                    $pdf->Ln($hRowDet);
                    $hNow+=$hRowDet;
                }
            }
            //END TOTALES
        }
    }
    $pdf->Output("VENTAS-DIARIAS".(intval($vTipo)>=0?(intval($vTipo)==0?'-MERCADERIA':'-SERVICIOS'):'').".pdf", 'I');
    ?>
