<?
    header("Cache-Control: no-store, no-cache, must-revalidate"); 
    header("Pragma: no-cache");

    require_once("../../config.php");
    require_once(INTERFAZ."/seguridad.php");
    require_once(LOGICA."/Acceso.php");
    require_once(HERRAMIENTAS_PHP."/pdf.php");
    require_once(HERRAMIENTAS_PHP."/tcpdf/config/lang/eng.php");
    require_once(HERRAMIENTAS_PHP."/tcpdf/tcpdf.php");
    require_once(HERRAMIENTAS_PHP."/FunctionsPDF.php");

    class MYPDF extends TCPDF {	
        public $rowWidth;
        public $arrMeses;
        public $pUsuario;
        public $pTitulo;
        public $pSubTitulo;
        public $pDescripcion;
        public function Header() {
            $wAux=getPageWidth($this);
            $this->SetFillColor(240);
            $hAux=11; $this->Cell(0, $hAux, ""); $this->Ln($hAux);
            $hAux=7; PrintCell($this, $this->pTitulo, $wAux, $hAux, 10, 1, "C", true, 'B'); $this->Ln($hAux);
            $hAux=7; PrintCell($this, $this->pSubTitulo, $wAux, $hAux, 10, 1, "C", false, 'B'); $this->Ln($hAux);
            
            $this->SetFont('helvetica', 'B', 8);
            $hAux=5;
            PrintCell($this, "N°", $this->rowWidth['orden'], $hAux, 8, 1, 'C', true, "B");
            PrintCell($this, " ALMACEN", $this->rowWidth['almacen'], $hAux, 8, 1, 'L', true, "B");
            foreach($this->arrMeses as $iMes=>$rowMes){
                $vValor=strtoupper(MonthName(intval($rowMes['mesid']), false));
                PrintCell($this, $vValor, $this->rowWidth['importe'], $hAux, 8, 1, 'C', true, "B");
            }
            PrintCell($this, "TOTAL ", $this->rowWidth['total'], $hAux, 8, 1, 'R', true, "B");
        }

        public function Footer(){
            $this->SetY(-15);
            $this->SetFont('helvetica', 'I', 7);
            $this->Cell(0,10, date('d/m/Y h:i:s a')."   USUARIO: ".$this->pUsuario, "T", 0, 'L');
            $this->Cell(0,10,'Pagina '.$this->PageNo().'/'.$this->getAliasNbPages(),0,0,'R');
        }
    }
    
    //BEGIN OBTENIENDO VALORES
    ob_end_clean();
    $array=$_GET;
    $vEmpresaId=intval($array['empresaid']);
    $vTipo=intval($array['tipo']);
    $vZonaId=intval($array['zonaid']);
    $vAno=intval($array['ano']);
    //END OBTENIENDO VALORES

    $oE=new Acceso_clsEmpresa();
    $oZ=new Acceso_clsZona();
    $oA=new Acceso_clsPermisos_Almacen();
    $oR=new Acceso_Inventarios_clsReportes();

    $rowEmpresa=$oE->getROW($vEmpresaId);
    $vZonaNombre="TODAS LAS ZONAS";
    if($vZonaId>0){
        $rowZona=$oZ->getROW($vZonaId);
        $vZonaNombre=$rowZona['nombre'];
    }
    $vTipoNombre="TODOS LOS TIPOS";
    if($vTipo>=0){
        $vTipoNombre=($vTipo==0?'MERCADERIA':'SERVICIOS');
    }

    //BEGIN LEER DATA
    $rsAlm=$oA->LeerAlmacenes($vEmpresaId, $sessCodigo, 0, $vZonaId);
    $rsRpt=$oR->VentasMensuales($vEmpresaId, $vTipo, $vAno, $vZonaId, 0);

    $arrAlm=array(); if($rsAlm) $arrAlm=$rsAlm->fetchAll(PDO::FETCH_ASSOC);
    $arrAux=array(); if($rsRpt) $arrAux=$rsRpt->fetchAll(PDO::FETCH_ASSOC);

    $arrData=array();
    foreach($arrAux as $i=>$row){
        $arrData[$row['almacenid']][$row['mes']]=doubleval($row['total']);
    }
    
    $arrMes=array();
    for($vMes=1; $vMes<=intval(date('m')); $vMes++){
        $arrMes[$vMes]=array("mesid"=>$vMes, "nombre"=> strtoupper(MonthName($vMes, false)), "abreviatura"=>strtoupper(MonthName($vMes, true)));
    }
    //END LEER DATA
    
    $pdf = new MYPDF("L", PDF_UNIT, PDF_PAGE_FORMAT, true, 'UTF-8', false); 
    $pdf->SetCreator(PDF_CREATOR);
    $pdf->setPrintHeader(true);
    $pdf->setPrintFooter(true);
    $pdf->SetDefaultMonospacedFont(PDF_FONT_MONOSPACED);
    $pdf->SetMargins(10, 30, 10);
    $pdf->SetHeaderMargin(0);
    $pdf->SetFooterMargin(0);
    $pdf->SetAutoPageBreak(true, 15);
    $pdf->setImageScale(PDF_IMAGE_SCALE_RATIO); 
    $pdf->setLanguageArray($l); 
    $pdf->pUsuario=$sessUsuario;
    $pdf->rowWidth=$rowWidth;
    $pdf->arrMeses=$arrMes;
    $pdf->pTitulo='VENTAS MENSUALES / AÑO '.$vAno.(trim($vTipoNombre)!=''?' / '.$vTipoNombre:'');
    $pdf->pSubTitulo=$rowEmpresa['nombre'].' / '.$vZonaNombre;
    $pdf->SetTitle('VENTAS MENSUALES / AÑO '.$vAno." / ".$rowEmpresa['nombre'].(trim($vTipoNombre)!=''?' / '.$vTipoNombre:''));

    $fsSize=8; $hRowDet=5;
    $hNow=0;
    $pdf->SetFont('helvetica', '', $fsSize);

    //BEGIN CALCULAMOS EL ANCHO DE COLUMNAS
    $wPage=getPageWidth($pdf);
    $hPage=getPageHeight($pdf);

    $wOrden=6; $wAlmacen=30; $wTotales=20;
    $wData=$wPage-($wTotales)-$wOrden-$wAlmacen;
    $wColData=16;
    $wColDataAux=($wData/count($arrMes));
    if($wColDataAux>$wColData){
        $wAlmacen=$wPage-($wTotales)-$wOrden-(count($arrMes)*$wColData);
    }else{
        $wColData=$wColDataAux;
    }
    //END CALCULAMOS EL ANCHO DE COLUMNAS

    $rowWidth=array("orden"=>$wOrden, "almacen"=>$wAlmacen, "importe"=>$wColData, "total"=>$wTotales);
    $pdf->rowWidth=$rowWidth;

    $pdf->AddPage();
    
    $vContador=0;
    $pdf->SetFillColor(240);
    $arrTotales=array();
    if(count($arrAlm)>0){
        foreach($arrAlm as $ic=>$rowAlm){
            $vAlmacenIdAux=intval($rowAlm['almacenid']);
            $vContador++;

            $pdf->SetFont('helvetica', '', $fsSize);

            PrintCell($pdf, $vContador, $rowWidth['orden'], $hRowDet, $fsSize, 1, 'C');
            PrintCell($pdf, $rowAlm['nombre'], $rowWidth['almacen'], $hRowDet, $fsSize, 1, 'L');

            $vTotalFila=0;
            foreach($arrMes as $im=>$rowMes){
                $vValor="";
                if(isset($arrData[$vAlmacenIdAux][$rowMes['mesid']])){
                    $vImporteAux=doubleval($arrData[$vAlmacenIdAux][$rowMes['mesid']]);
                    $vTotalFila+=doubleval($vImporteAux);
                    $vValor=number_format($vImporteAux,2);
                    $arrTotales[$rowMes['mesid']]+=$vImporteAux;
                }
                PrintCell($pdf, $vValor, $rowWidth['importe'], $hRowDet, $fsSize, 1, 'R');
            }
            
            $pdf->SetFont('helvetica', 'B', 8);
            $vValor=($vTotalFila==0?'':number_format($vTotalFila, 2));
            PrintCell($pdf, $vValor, $rowWidth['total'], $hRowDet, $fsSize, 1, 'R', true, "B");
            
            $pdf->Ln($hRowDet);
        }

        //BEGIN TOTALES
        $pdf->SetFont('helvetica', 'B', 8);        
        PrintCell($pdf, "TOTALES", $rowWidth['orden']+$rowWidth['almacen'], $hRowDet, $fsSize, 1, 'L', true, "B");
        $vTotalFila=0;
        foreach($arrMes as $im=>$rowMes){
            $vValor="";
            if(isset($arrTotales[$rowMes['mesid']])){
                $vImporteAux=doubleval($arrTotales[$rowMes['mesid']]);
                $vValor=number_format($vImporteAux,2);
                $vTotalFila+=$vImporteAux;
            }
            PrintCell($pdf, $vValor, $rowWidth['importe'], $hRowDet, $fsSize, 1, 'R', true, "B");
        }
        $vValor=($vTotalFila==0?'':number_format($vTotalFila, 2));
        PrintCell($pdf, $vValor, $rowWidth['total'], $hRowDet, $fsSize, 1, 'R', true, "B");
        //END TOTALES
    }
    
    $pdf->Output("VENTAS-MENSUALES".(intval($vTipo)>=0?(intval($vTipo)==0?'-MERCADERIA':'-SERVICIOS'):'').".pdf", 'I');
    ?>
