<?
    header("Cache-Control: no-store, no-cache, must-revalidate");
    header("Pragma: no-cache");

    require_once("../../config.php");
    require_once(INTERFAZ."/seguridad.php");
    require_once("Spreadsheet/Excel/Writer.php");
    require_once(LOGICA."/Acceso.php");

    if ($_GET) $array=$_GET;
    else $array=$_POST;

    //BEGIN OBTENIENDO VALORES
    $array=$_GET;
    $vEmpresaId=intval($array['empresaid']);
    $vTipo=intval($array['tipo']);
    $vZonaId=intval($array['zonaid']);
    $vAno=intval($array['ano']);
    //END OBTENIENDO VALORES

    $oE=new Acceso_clsEmpresa();
    $oZ=new Acceso_clsZona();
    $oA=new Acceso_clsPermisos_Almacen();
    $oR=new Acceso_Inventarios_clsReportes();

    $rowEmpresa=$oE->getROW($vEmpresaId);
    $vZonaNombre="TODAS LAS ZONAS";
    if($vZonaId>0){
        $rowZona=$oZ->getROW($vZonaId);
        $vZonaNombre=$rowZona['nombre'];
    }
    $vTipoNombre="TODOS LOS TIPOS";
    if($vTipo>=0){
        $vTipoNombre=($vTipo==0?'MERCADERIA':'SERVICIOS');
    }

    //BEGIN LEER DATA
    $rsAlm=$oA->LeerAlmacenes($vEmpresaId, $sessCodigo, 0, $vZonaId);
    $rsRpt=$oR->VentasMensuales($vEmpresaId, $vTipo, $vAno, $vZonaId, 0);

    $arrAlm=array(); if($rsAlm) $arrAlm=$rsAlm->fetchAll(PDO::FETCH_ASSOC);
    $arrAux=array(); if($rsRpt) $arrAux=$rsRpt->fetchAll(PDO::FETCH_ASSOC);

    $arrData=array();
    foreach($arrAux as $i=>$row){
        $arrData[$row['almacenid']][$row['mes']]=doubleval($row['total']);
    }

    $arrMes=array();
    for($vMes=1; $vMes<=intval(date('m')); $vMes++){
        $arrMes[$vMes]=array("mesid"=>$vMes, "nombre"=> strtoupper(MonthName($vMes, false)), "abreviatura"=>strtoupper(MonthName($vMes, true)));
    }
    //END LEER DATA

    $xls = new Spreadsheet_Excel_Writer();

    $fTit=$xls->addFormat(array("bold"=>1, "align"=>'center', "valign"=>'vequal_space', "fgcolor"=>50, 'size'=>12, "border"=>1));
    $fTitDatos=$xls->addFormat(array("bold"=>1, "align"=>'left', "valign"=>'top', "fgcolor"=>50, "border"=>1));
    $fLeft=$xls->addFormat(array("border"=>1,"align"=>'left'));
    $fCenter=$xls->addFormat(array("border"=>1,"align"=>'center'));
    $fRight=$xls->addFormat(array("border"=>1,"align"=>'right'));
    $fImporte=$xls->addFormat(array("border"=>1,"align"=>'right', "numformat"=>'#,##0.00'));
    $fCab=$xls->addFormat(array("bold"=>1,"border"=>1,"align"=>'center',"fgcolor"=>43));
    $fCabLeft=$xls->addFormat(array("bold"=>1, "border"=>1, "align"=>'left', "fgcolor"=>43));
    $fCabRight=$xls->addFormat(array("bold"=>1, "border"=>1, "align"=>'right', "fgcolor"=>43));

    $sheet = $xls->addWorksheet("");
    $vFila=0;
    $vColumna=1;
    
    $vColIni=1;
    $vCantColData=count($arrMes);
    $vUltCol=$vColIni + $vCantColData + 1;

    $sheet->setColumn($vColumna, $vColumna, 5); //ITEM
    $sheet->setColumn($vColumna+1, $vColumna+1, 40); //ALMACEN
    $sheet->setColumn($vColumna+2, $vUltCol, 15); //IMPORTES
    $sheet->setColumn($vUltCol+1, $vUltCol+1, 15); //TOTALES

    $vFila++;
    $vColumna=$vColIni;
    $sheet->write($vFila, $vColumna, Almacenar_Dato_Excel('VENTAS MENSUALES / AÑO '.$vAno.(trim($vTipoNombre)!=''?' / '.$vTipoNombre:'')), $fTitDatos);
    $vColAuxIni=$vColumna;
    for($vNum=1; $vNum<=$vCantColData+2; $vNum++){ $vColumna++; $sheet->write($vFila, $vColumna, "", $fTitDatos); }
    $sheet->setMerge($vFila, $vColAuxIni, $vFila, $vColumna);

    $vFila++;
    $vColumna=$vColIni;
    $sheet->write($vFila, $vColumna, Almacenar_Dato_Excel($rowEmpresa['nombre'].' / '.$vZonaNombre), $fTitDatos);
    $vColAuxIni=$vColumna;
    for($vNum=1; $vNum<=$vCantColData+2; $vNum++){ $vColumna++; $sheet->write($vFila, $vColumna, "", $fTitDatos); }
    $sheet->setMerge($vFila, $vColAuxIni, $vFila, $vColumna);

    $vFila++;
    $vColumna=$vColIni;
    $sheet->write($vFila, $vColumna, Almacenar_Dato_Excel("N°"), $fCab);
    $sheet->write($vFila, $vColumna+1, Almacenar_Dato_Excel("ALMACEN"), $fCabLeft);
    $vColumna++;
    foreach($arrMes as $im=>$rowMes){
        $vMes=intval($rowMes['mesid']);
        $vColumna++;
        $sheet->write($vFila, $vColumna, MonthName($vMes, false), $fCab);
    }
    $vColumna++;
    $sheet->write($vFila, $vColumna, "TOTAL", $fCab);
    if(count($arrAlm)>0){
        foreach($arrAlm as $iAlm=>$rowAlm){
            $vAlmacenId=intval($rowAlm['almacenid']);
            $vColumna=$vColIni;
            $vFila++;
            $sheet->write($vFila, $vColumna, ($iAlm+1), $fCenter);
            $vColumna++;
            $sheet->write($vFila, $vColumna, Almacenar_Dato_Excel($rowAlm['nombre']), $fLeft);
            $vColumna++;
            foreach($arrMes as $im=>$rowMes){
                $vValor=0;
                if(isset($arrData[$vAlmacenId][$rowMes['mesid']])){
                    $vValor=doubleval($arrData[$vAlmacenId][$rowMes['mesid']]);
                }
                $sheet->write($vFila, $vColumna, ($vValor==0?'':$vValor), $fImporte);
                $vColumna++;
            }
            //BEGIN TOTALES POR FILA
            $fCellIni=$xls->rowcolToCell($vFila, $vColumna - $vCantColData);
            $fCellFin=$xls->rowcolToCell($vFila, $vColumna-1);
            $vFormula="=SUM($fCellIni:$fCellFin))";
            $sheet->writeFormula($vFila, $vColumna, $vFormula, $fImporte);
            //END TOTALES POR FILA
        }
        //BEGIN TOTALES POR COLUMNA
        $vColumna=$vColIni;
        $vFila++;
        $sheet->write($vFila, $vColumna, "TOTALES", $fCab);
        $sheet->write($vFila, $vColumna+1, "", $fCab);
        $sheet->setMerge($vFila, $vColumna, $vFila, $vColumna+1);
        $vColumna++;
        $vColumna++;
        foreach($arrMes as $im=>$rowMes){
            $fCellIni=$xls->rowcolToCell($vFila-count($arrAlm), $vColumna);
            $fCellFin=$xls->rowcolToCell($vFila-1, $vColumna);
            $vFormula="=SUM($fCellIni:$fCellFin))";
            $sheet->writeFormula($vFila, $vColumna, $vFormula, $fImporte);
            $vColumna++;
        }
        $fCellIni=$xls->rowcolToCell($vFila-count($arrAlm), $vColumna);
        $fCellFin=$xls->rowcolToCell($vFila-1, $vColumna);
        $vFormula="=SUM($fCellIni:$fCellFin))";
        $sheet->writeFormula($vFila, $vColumna, $vFormula, $fImporte);
        //END TOTALES POR COLUMNA
    }
    $xls->send("VENTAS-MENSUALES".(intval($vTipo)>=0?(intval($vTipo)==0?'-MERCADERIA':'-SERVICIOS'):'').".xls");
    $xls->close();	
?>