<?
class FTP{
    public $pServer;
    public $pUser;
    public $pPassword;
    public $pPort;
    public $pFile;
    public $pMaxSize;//Kb
    public $pExtensions;
    public $pHeight;
    public $pWidth;
    public $pTemp;
    public $pResize;
    public $pResizeOption;
    public $arrErr=array();
    public $pConexion;

    function __construct(){ 
        $this->pFile="";
        $this->pMaxSize=1024;
        $this->pExtensions=array("rar","zip","gif","jpg","png");
        $this->pHeight=0;
        $this->pWidth=0;
        $this->pTemp="/tmp/";
        $this->pResize=false;
        $this->pResizeOption='auto';
        $this->arrErrores=array(
            100 => "El archivo tiene una extension no permitida.",
            101 => "El tama&ntilde;o del archivo excede el permitido.",
            102 => "Las dimensiones(ancho,alto) de la imagen no son las permitidas.",
            103 => "Error al subir el archivo.",
            105 => "Resize: File is not image."
        );
        $this->pConexion=false;
    }
    function MsgErr($vCodigo){
        return $this->arrErrores[intval($vCodigo)];
    }
    function Upload($vNuevo_Nombre, $vPath){
        $vNombre_Archivo=$_FILES[$this->pFile]['name'];
        $miArr=explode(".",$vNombre_Archivo);
        $vExtension=$miArr[count($miArr)-1]; //Extension
        if (is_array($this->pExtensions)){
            if (count($this->pExtensions)>0){
                if (!in_array(trim(strtolower($vExtension)),$this->pExtensions)){
                    return 100;
                }
            }
        }

        $vTamano=$_FILES[$this->pFile]['size']; //Tamano
        $vTamano=round(($vTamano/1024),2);
        if (doubleval($vTamano) > doubleval($this->pMaxSize)){
            return 101;
        }

        if($this->pResize){
            $vFileNameTmp=$_FILES[$this->pFile]['tmp_name'];
            if(IsImage($vFileNameTmp)){
                $vFileNameTmpNew=tempnam("/tmp", "RESIZE");

                $oR=new clsResize($vFileNameTmp);
                $oR->resizeImage($this->pWidth, $this->pHeight, $this->pResizeOption);
                $oR->saveImage($vFileNameTmpNew);

                $vRpta=$this->Put($vFileNameTmpNew, $vPath.$vNuevo_Nombre);

                if (!$vRpta) return 103;
                else return 0;
            }else return 105;
        }else{
            $vRpta=$this->Put($_FILES[$this->pFile]['tmp_name'], $vPath.$vNuevo_Nombre);

            if (!$vRpta) return 103;
            else return 0;
        }
    }
    function Connect(){
        $vConnect=false;
        if ($vConnect=@ftp_connect($this->pServer,$this->pPort)){
            if (@ftp_login($vConnect,$this->pUser,$this->pPassword)){
                if (@ftp_pasv($vConnect, true)){
                }
            }				
        }
        $this->pConexion=$vConnect;
        return $vConnect;
    }

    function File_Exists($vPath, $vFile){
        $vRpta=false;
        $vFTP=($this->pConexion?$this->pConexion:$this->Connect());
        if ($vFTP){
            $vSize=ftp_size($vFTP , $vPath.$vFile);
            if ($vSize!=-1){
                $vRpta=true;
            }
        }
        return $vRpta;
    }
    function Directory_Exists($vPath){
        $vRpta=false;
        $vFTP=($this->pConexion?$this->pConexion:$this->Connect());
        if ($vFTP){
            if (@ftp_chdir($vFTP, $vPath)){
                $vRpta=true;
            }
        }
        return $vRpta;
    }
    function Size($vFile){
        $vSize=false;
        $vFTP=($this->pConexion?$this->pConexion:$this->Connect());
        if ($vFTP){
            $vSize=ftp_size($vFTP, $vFile);
            if($vSize==-1) $vSize=false;
        }
        return $vSize;
    }

    function Delete_File($vFile) {
        $vRpta=false;
        $vFTP=($this->pConexion?$this->pConexion:$this->Connect());
        if ($vFTP){
            if (@ftp_delete($vFTP, $vFile)){
                $vRpta=true;
            }
        }
        return $vRpta;
    }
    function Delete_Dir($vDirectory) {
        $vRpta=false;
        $vFTP=($this->pConexion?$this->pConexion:$this->Connect());
        if ($vFTP){
            if (ftp_rmdir($vFTP, $vDirectory)){
                $vRpta=true;
            }
        }
        return $vRpta;
    }
    function Create_Dir($vDirectory) {
        $vRpta=false;
        $vFTP=($this->pConexion?$this->pConexion:$this->Connect());
        if ($vFTP){
            if (ftp_mkdir($vFTP, $vDirectory)){
                $vRpta=true;
            }
        }
        return $vRpta;
    }

    function Get($vFile){
        $vRpta=false;
        $vFTP=($this->pConexion?$this->pConexion:$this->Connect());
        if ($vFTP){
            if (!$this->File_Exists("", $vFile)) {die("File not found"); return false;}
            if(ftp_get($vFTP, $this->pTemp.basename($vFile), $vFile, FTP_BINARY)){
                $vRpta=true;
            }
        }
        return $vRpta;
    }
    function Put($vFileLocal, $vFileServer){
        $vRpta=false;
        $vFTP=($this->pConexion?$this->pConexion:$this->Connect());
        if ($vFTP){
            if (@ftp_put($vFTP , $vFileServer, $vFileLocal, FTP_BINARY)){
                $vRpta=true;
            }
        }
        return $vRpta;
    }

    function Download($vFile){
        if($this->Get($vFile)){
            $vFileExt = strtolower(substr(strrchr($vFile, "."), 1));
            switch ($vFileExt) {
                case "pdf": $ctype="application/pdf"; break;
                case "exe": $ctype="application/octet-stream"; break;
                case "zip": $ctype="application/zip"; break;
                case "doc": $ctype="application/msword"; break;
                case "xls": $ctype="application/vnd.ms-excel"; break;
                case "ppt": $ctype="application/vnd.ms-powerpoint"; break;
                case "gif": $ctype="image/gif"; break;
                case "png": $ctype="image/png"; break;
                case "jpe": case "jpeg":
                case "jpg": $ctype="image/jpg"; break;
                default: $ctype="application/force-download";
            }

            header("Pragma: public");
            header("Expires: 0");
            header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
            header("Cache-Control: private",false);
            header("Content-Type: $ctype");
            header("Content-Disposition: attachment; filename=\"".basename($vFile)."\";");
            header("Content-Transfer-Encoding: binary");
            header("Content-Length: ".$this->Size($vFile));

            @readfile($this->pTemp.basename($vFile)) or die("Unexpected error.");
        }else{
            return false;
        }
    }

    function getDataFile(){
        $vNombre_Archivo=$_FILES[$this->pFile]['name'];
        //Obtenemos los datos del archivo
        $miArr=explode(".",$vNombre_Archivo);
        $vExtension=$miArr[count($miArr)-1]; //Extension
        $vTamano=$_FILES[$this->pFile]['size']; //Tamano
        $vTamano=round(($vTamano/1024),2);
        $vDimensiones=getimagesize($_FILES[$this->pFile]['tmp_name']); //Dimensiones

        $arrDatos_Archivo=array("nombre"=>$vNombre_Archivo, 
            "extension"=>$vExtension,
            "tamano"=>$vTamano,
            "ancho"=>$vDimensiones[0],
            "alto"=>$vDimensiones[1]
        );
        return $arrDatos_Archivo;
    }

    function ReadDir($vDirectory) {
        $vRpta=false;
        $myArray=array();
        $vFTP=($this->pConexion?$this->pConexion:$this->Connect());
        if ($vFTP){
            $arr= ftp_nlist($vFTP, $vDirectory);
            if(is_array($arr)){
                foreach($arr as $i=>$myFile){
                    if(!($myFile=="." || $myFile=="..")){
                        $vSize=ftp_size($vFTP, $vDirectory.$myFile);
                        $myArray[]=array("name"=>$myFile, "size"=>$vSize);
                    }
                }
                return $myArray;
            }else return false;
        }else return false;
    }
    function Dimensions($vFile){
        $vRpta=false;
        $vFTP=($this->pConexion?$this->pConexion:$this->Connect());
        if ($vFTP){
            if ($this->File_Exists("", $vFile)){
                if(ftp_get($vFTP, $this->pTemp.basename($vFile), $vFile, FTP_BINARY)){
                    $arrDim=getimagesize($this->pTemp.basename($vFile));
                    return array("width"=>doubleval($arrDim[0]), "height"=>doubleval($arrDim[1]));
                }
            }
        }
        return $vRpta;
    }
    function NewFileName($myPathFile, $myFileName){
        $vFTP=($this->pConexion?$this->pConexion:$this->Connect());

        //SEPARAMOS EL NOMBRE DE LA EXTENSION
        $miArr=explode(".", $myFileName);
        if(count($miArr)>1){
            $fileExt=$miArr[count($miArr)-1]; //Extension
            $fileName=substr($myFileName, 0, strlen($myFileName) - strlen($fileExt)-1);
        }else{
            $fileExt="";
            $fileName=$myFileName;
        }

        $vContador=1;
        $myFile=$myPathFile.$myFileName;
        $myNewFileName=$myFileName;
        if ($vFTP){
            while(true){
                if ($this->File_Exists($myPathFile, $myNewFileName)){
                    $vContador++;
                    $myNewFileName=$fileName."_".$vContador.".".$fileExt;
                    $myFile=$myPathFile.$myNewFileName;
                }else{
                    break;
                }
            }
        }
        return $myNewFileName;
    }
}
?>