<?php
    define ('A4_WIDTH_PORTRAIT', 190.000144444);
    define ('A4_WIDTH_LANDSCAPE', 277.000083333);
    function RotateText($vAncho, $vAlto, $vTexto, $vFontSize=0, $vAngulo=-90, $vBorder=1, $vAlign="C", $vBackgroundColor=true, $vStyle='', $vFontFamily='helvetica'){
        global $pdf;
        $vXAux=$pdf->getX(); $vYAux=$pdf->getY(); $pdf->setX($vXAux+$vAncho); $pdf->StartTransform(); $pdf->Rotate($vAngulo);
        $vValor=$vTexto;
        $pdf->SetFontSize(FontSizeMin($pdf, $vValor, ($vAlto-($vAlto*0.05)), $vFontSize));
        $pdf->SetFont($vFontFamily, $vStyle);
        $pdf->Cell($vAlto, $vAncho, $vValor, $vBorder, 0, $vAlign, $vBackgroundColor);
        $pdf->StopTransform(); $pdf->setXY($vXAux+$vAncho, $vYAux);
    }
    function getPageWH($pdf){
        $wPage=$pdf->getPageWidth();
        $hPage=$pdf->getPageHeight();
        $arrMargins=$pdf->getMargins();
        $wPage-=($arrMargins['left']+$arrMargins['right']);
        $hPage-=($arrMargins['top']+$arrMargins['bottom']);
        return array("width"=>$wPage, "height"=>$hPage);
    }
    function PrintCell($pdf, $vValor='', $wAux=0, $hAux=5, $vFontSize=8, $vBorder=0, $vAlign='L', $vBackgroundColor=false, $vStyle='', $vFontFamily='helvetica'){
        if(intval($vFontSize)>0){
            $vFS=intval($vFontSize);
            if(intval($wAux)>0){
                $vFS=FontSizeMin($pdf, $vValor, intval($wAux)-(intval($wAux)*0.05), intval($vFontSize));
            }
            $pdf->SetFontSize($vFS);
        }
        $pdf->SetFont($vFontFamily, $vStyle);
        $pdf->Cell($wAux, $hAux, $vValor, $vBorder, 0, $vAlign, $vBackgroundColor);
    }

    function PrintRow($pdf, $arrRow, $rowData, $vIndice=0, $hAux=5, $vBackgroundColor=false, $vBorder=0, $vFontSize=8){
        foreach($arrRow as $iRow=>$rowH){
            $vValor='';
            switch($rowH['tipo']){
                case 'NO':  $vValor=($vIndice+1); break;
                case 'D':   $vValor=FormatDate($rowData[$rowH['name']]); break;
                case 'N':   $vValor=number_format(doubleval($rowData[$rowH['name']]),2); break;
                case 'I':   $vValor=intval($rowData[$rowH['name']]); break;
                case 'DOUBLE':   $vValor=doubleval($rowData[$rowH['name']]); break;
                default:    $vValor=$rowData[$rowH['name']];
            }
            $pdf->SetFontSize(FontSizeMin($pdf, $vValor, $rowH['width']-($rowH['width']*0.05), $vFontSize));
            $pdf->Cell($rowH['width'], $hAux, $vValor, $vBorder, 0, $rowH['align'], $vBackgroundColor );
        }        
    }
    function PrintRowHeader($pdf, $arrRow, $hAux=5, $vBorder=0, $vBackgroundColor=false, $vFontSize=8, $vStyle='B', $vFontFamily='helvetica'){
        foreach($arrRow as $iRow=>$rowH){
            $vRotate=false; if(isset($rowH['rotate'])) $vRotate=$rowH['rotate'];
            if($vRotate){
                RotateText($rowH['width'], $hAux, $rowH['caption'], $vFontSize, -90, $vBorder, $rowH['align'], $vBackgroundColor, $vStyle, $vFontFamily);
            }else{
                PrintCell($pdf, $rowH['caption'], $rowH['width'], $hAux, $vFontSize, $vBorder, $rowH['align'], $vBackgroundColor, $vStyle, $vFontFamily);
            }
        }        
    }
    function PrintRowHead($pdf, $arrRow, $hAux=5, $vBorder=0, $vBackgroundColor=false, $vFontSize=8, $vStyle='B', $vFontFamily='helvetica'){
        foreach($arrRow as $iRow=>$rowH){
            $vRotate=false; if(isset($rowH['rotate'])) $vRotate=$rowH['rotate'];
            if($vRotate){
                RotateText($rowH['width'], $hAux, $rowH['caption'], $vFontSize, -90, $vBorder, $rowH['align'], $vBackgroundColor, $vStyle, $vFontFamily);
            }else{
                PrintCell($pdf, $rowH['caption'], $rowH['width'], $hAux, $vFontSize, $vBorder, $rowH['align'], $vBackgroundColor, $vStyle, $vFontFamily);
            }
        }        
    }
    
    function getPageHeight($pdf){
	$hPage=$pdf->getPageHeight();
	$arrMargins=$pdf->getMargins();
	$hPage-=($arrMargins['top']+$arrMargins['bottom']);
        return $hPage;
    }
    function getPageWidth($pdf){
	$wPage=$pdf->getPageWidth();
	$arrMargins=$pdf->getMargins();
	$wPage-=($arrMargins['left']+$arrMargins['right']);
        return $wPage;
    }
    
    function WidthCols($arrCols, $vFitWidth=''){
        $wAux=0;
        if(is_array($arrCols)){
            if(count($arrCols)>0){
                foreach($arrCols as $i=>$row){
                    switch(strtoupper($vFitWidth)){
                        case "Y": $wAux+=(doubleval($row['fitwidth'])>0?doubleval($row['width']):0); break;
                        case "N": $wAux+=(doubleval($row['fitwidth'])<=0?doubleval($row['width']):0); break;
                        default: $wAux+=doubleval($row['width']);
                    }
                }
            }
        }
        return $wAux;
    }
    function ColsFit($arrCols, $vTipo=''){
        $wAux=0;
        if(is_array($arrCols)){
            if(count($arrCols)>0){
                foreach($arrCols as $i=>$row){
                    if(doubleval($row['fitwidth'])>0){
                        switch($vTipo){
                            case 'sum': $wAux+=doubleval($row['fitwidth']); break;
                            case 'count': $wAux++; break;
                        }
                    }
                }
            }
        }
        return $wAux;
    }
    function FitWidthCols($arrCols, $wWidth1, $wWidth2){
        $myArr=$arrCols;
        if(is_array($myArr)){
            if(count($myArr)>0){
                
                //VERIFICAMPS QUE LA SUMATORIA TOTAL DE LAS COLUMNAS FIT SEA 100%
                /*
                $wFit=ColsFit($myArr, 'sum');
                $vColsFitCount=ColsFit($myArr, 'count');
                if($wFit!=100){
                    $wDiff=abs($wFit-100);
                    foreach($myArr as $i=>$row){
                        if(doubleval($row['fitwidth'])>0){
                            $wAux=doubleval($row['fitwidth']);
                            if($wFit>100){
                                $myArr[$i]['fitwidth']=($wAux-($wDiff/$vColsFitCount));
                            }else{
                                $myArr[$i]['fitwidth']=($wAux+($wDiff/$vColsFitCount));
                            }
                        }
                    }
                }
                */
                
                //AJUSTAMOS LAS COLUMNAS QUE DEBERIAN SER AJUSTADAS
                $wCols=WidthCols($myArr);
                $wReport=($wCols>$wWidth1?$wWidth2:$wWidth1);
                if($wCols<$wReport){//ACA AMPLIAMOS LAS COLUMNAS CORRESPONDIENTES (FITWIDTH)
                    $wDiff=($wReport-$wCols); //ESTO SOBRA
                    foreach($myArr as $i=>$row){
                        if(doubleval($row['fitwidth'])>0){
                            $wAux=doubleval($row['width']);
                            $myArr[$i]['width']=($wAux+($wDiff*doubleval($row['fitwidth'])/100));
                        }
                    }
                }else{
                    $wDiff=($wCols-$wReport); //ESTO FALTA
                    foreach($myArr as $i=>$row){
                        if(doubleval($row['fitwidth'])>0){
                            $wAux=doubleval($row['width']);
                            $myArr[$i]['width']=($wAux-($wDiff*doubleval($row['fitwidth'])/100));
                        }
                    }
                }
            }
        }
        return $myArr;
    }
    
    function getPageOrientation($arrCols, $wWidth){
        $wCols=WidthCols($arrCols);
        return ($wCols<=$wWidth?"P":"L");
    }
    function AddSumTotal($myArr, $rowData){
        foreach($myArr as $iAux=>$vImporte){
            if(isset($rowData[$iAux])){
                $myArr[$iAux]+=doubleval($rowData[$iAux]);
            }
        }
        return $myArr;
    }
    function getWidthColumn($myArr, $vColumnName){
        $wAux=0;
        foreach($myArr as $iAux=>$rowAux){
            if(trim($rowAux['name'])==$vColumnName){
                $wAux=doubleval($rowAux['width']);
            }
        }
        return $wAux;
    }
?>