<?php
	require_once('config/lang/eng.php');
	require_once('tcpdf.php');
	// create new PDF document
	$pdf = new TCPDF(PDF_PAGE_ORIENTATION, PDF_UNIT, PDF_PAGE_FORMAT, true, 'UTF-8', false); 
	// set document information
	$pdf->SetCreator(PDF_CREATOR);
	$pdf->SetAuthor('Nicola Asuni');
	$pdf->SetTitle('TCPDF Example 048');
	$pdf->SetSubject('TCPDF Tutorial');
	$pdf->SetKeywords('TCPDF, PDF, example, test, guide');
	// set default header data
	$pdf->SetHeaderData(PDF_HEADER_LOGO, PDF_HEADER_LOGO_WIDTH, PDF_HEADER_TITLE, PDF_HEADER_STRING);
	// set header and footer fonts
	$pdf->setHeaderFont(Array(PDF_FONT_NAME_MAIN, '', PDF_FONT_SIZE_MAIN));
	$pdf->setFooterFont(Array(PDF_FONT_NAME_DATA, '', PDF_FONT_SIZE_DATA));
	// set default monospaced font
	$pdf->SetDefaultMonospacedFont(PDF_FONT_MONOSPACED);
	//set margins
	$pdf->SetMargins(PDF_MARGIN_LEFT, PDF_MARGIN_TOP, PDF_MARGIN_RIGHT);
	$pdf->SetHeaderMargin(PDF_MARGIN_HEADER);
	$pdf->SetFooterMargin(PDF_MARGIN_FOOTER);
	//set auto page breaks
	$pdf->SetAutoPageBreak(TRUE, PDF_MARGIN_BOTTOM);
	//set image scale factor
	$pdf->setImageScale(PDF_IMAGE_SCALE_RATIO); 
	//set some language-dependent strings
	$pdf->setLanguageArray($l); 
	// set font
	$pdf->SetFont('helvetica', '', 8);
	// add a page
	$pdf->AddPage();

	ob_start();
	?>
    <table width="100%" border="1" cellpadding="0">
    	<tr>
        	<td bgcolor="#006666" align="center">Col1</td>
            <td>Col2</td>
        </tr>
        <tr>
        	<td colspan="2" align="center">
            	<table width="50%" border="1">
                	<tr>
                    	<td align="center">Col1</td>
                    	<td align="center">Col2</td>
                    	<td align="center">Col3</td>
                    </tr>
                </table>
            </td>
        </tr>
    </table>
	<?
	$html=ob_get_contents();
	ob_get_clean();	
	$pdf->writeHTML($html, true, false, false, false, '');
	
	$pdf->Output('ejemplo.pdf', 'I');
?>