<?php
require_once 'Generic.php';
class Productos extends Generic{
   
  
    public function listarProductos($search,$personaid){
   
        $statement = $this->instance->prepare("select productoid,nombre from catalogo.paproducto_consulta_app(50,:search,:personaid)");
        $statement instanceof PDOStatement;
        $statement->execute(array(
            "search" => $search,
            "personaid"=>$personaid
        ));
        $rpt = $statement->fetchAll(PDO::FETCH_OBJ);
        return $rpt;

    }
 
    
    public function listarAlmacenes($productoid){
   

        $statement = $this->instance->prepare("select * from catalogo.paproducto_almacen_consulta_stock(cast(extract(year from now()::timestamp) as integer),:productoid,0)");
        $statement instanceof PDOStatement;
        $statement->execute(array(
            "productoid" => $productoid
        ));
        $rpt = $statement->fetchAll();
        return $rpt;

    }
    
    
    
    public function listarPrecioAlmacenes($productoid){
   

        $statement = $this->instance->prepare("select * from catalogo.paproducto_almacen_consulta_stock"
                . "(cast(extract(year from now()::timestamp) as integer),:productoid,0)");
        $statement instanceof PDOStatement;
        $statement->execute(array(
            "productoid" => $productoid
        ));
        $rpt = $statement->fetchAll(PDO::FETCH_OBJ);
        return $rpt;

    }
    
    public function actualizarPrecioAlmacen($productoid,$personaid,$detalle){
        $sql = "select * from catalogo.paproducto_almacen_registrar( :productoid ,"
                . "array".(string)$detalle.", 0, false, :personaid , 'ANDROID'  )";
        $statement = $this->instance->prepare($sql);
        $statement instanceof PDOStatement;
        $statement->execute(array(
            "productoid" => $productoid,
            "personaid"=> $personaid,
        ));
        $rpt = $statement->fetchObject();
        return $rpt;
    }
    
    public function consultarDocumento($empresaid,$personaid,$search){
        
        $statement = $this->instance->prepare("select * from inventarios.paventa_leer( 0, 10, :empresaid, 0, 0, 0,"
                . " :personaid, 0, 0, '', '', '', '', :search ,0, '', '', 0  )");
        $statement instanceof PDOStatement;
        $statement->execute(array(
            "empresaid" => $empresaid,
            "personaid"=> $personaid,
            "search" => $search
        ));
        $row = $statement->fetchObject();
        if($row == null){
            return null;
        }
        $fecha=date_create($row->fecha);
        $nrpt = array(
            'ventaid'=> $row->ventaid,
            'tipodocumento' => $row->tipodocumento_nombre,
            'numero'=> $row->numero,
            'moneda'=> $row->simbolo_moneda,
            'fecha'=> date_format($fecha,'d-m-Y'),
            'total'=> $row->vta_total,
            'estado'=>$row->estado
        );
        
       return $nrpt;

    }
    
    public function listarMotivosAnulacionDoc(){
        $statement = $this->instance->prepare("select motivoid,nombre from inventarios.pamotivo_anulacion_leer()");
        $statement instanceof PDOStatement;
        $statement->execute();
        $rpt = $statement->fetchAll(PDO::FETCH_OBJ);
        return $rpt;
    }
    
    public function anularDocumento($ventaid,$motivoid,$observacion,$personaid){
        
        $statement = $this->instance->prepare("select * from inventarios.paventa_cambiar_estado"
                . "( :ventaid, false, :motivoid, :observacion, :personaid,'Android')");
        $statement instanceof PDOStatement;
        $statement->execute(array(
            "ventaid" => $ventaid,
            "motivoid"=> $motivoid,
            "observacion" => $observacion,
            "personaid"=>$personaid
        ));
        $rpt = $statement->fetchObject();
        return $rpt;
    }
    
}

