<?php
require_once 'Generic.php';
class Reportes extends Generic{
    
    
    public function listarAlmacenes($empresaid, $personaid,$zona){
        $statement = $this->instance->prepare("select almacenid,abreviatura,nombre from basic.papermisos_modulo_almacenes"
                . "(:empresaid,:personaid, 0,:zona, 0)");
        $statement instanceof PDOStatement;
        $statement->execute(array(
            "empresaid" => $empresaid,
            "personaid"=>$personaid,
            "zona"=>$zona
        ));
        $rpt = $statement->fetchAll(PDO::FETCH_OBJ);
        
        return $rpt;
    }  

    public function listarReporteMensual($empresaid,$tipo, $anio,$zona){
        $statement = $this->instance->prepare("select ano,mes,almacenid,total from inventarios.pareporte_resumen_ventas_mensual"
                . "( :empresaid,:tipo, :anio,:zona,0)");
        $statement instanceof PDOStatement;
        $statement->execute(array(
            "empresaid" => $empresaid,
            "tipo"=>$tipo,
            "anio"=>$anio,
            "zona"=>$zona
        ));
        $rpt = $statement->fetchAll(PDO::FETCH_OBJ);
        
        
        return $rpt;
    }
    
    
    
   public function listarVentasDiarias($empresaid,$tipo,$zona,$inicio,$fin){
        $statement = $this->instance->prepare("select dia,mes,ano,almacenid,total from inventarios.pareporte_resumen_ventas_diaria(:empresaid,:tipo,:zona,:finicio,:ffin)");
        $statement instanceof PDOStatement;
        $statement->execute(array(
            "empresaid" => $empresaid,
            "tipo"=>$tipo,
            "finicio"=>$inicio,
            "ffin"=>$fin,
            "zona"=>$zona
        ));
        $rpt = $statement->fetchAll(PDO::FETCH_OBJ);
        
        
        return $rpt;
    } 
    public function listarResumenStockGeneral($empresaid,$anio,$zona){
        $statement = $this->instance->prepare("select * from inventarios.pareporte_resumen_stock_general(:anio, :empresaid, :zona)");
        $statement instanceof PDOStatement;
        $statement->execute(array(
            "empresaid" => $empresaid,
            "anio"=>$anio,
            "zona"=>$zona
                
        ));
        $rpt = $statement->fetchAll(PDO::FETCH_OBJ);
        
        
        return $rpt;
    } 
    
    public function listarProductos(){
        
        $statement = $this->instance->prepare("select productoid,nombre from catalogo.producto");
        $statement instanceof PDOStatement;
        $statement->execute();
        $rpt = $statement->fetchAll(PDO::FETCH_OBJ);
        
        
        return $rpt;
    } 
    public function listarProductosMasVendidos($empresaid,$zona,$inicio,$fin){
        $statement = $this->instance->prepare("select productoid,producto,almacenid,cantidad,total from inventarios.pareporte_productos_mas_vendidos_detalle(:empresaid, :zona, 0, 0, '', 0, :finicio,:ffin)");
        $statement instanceof PDOStatement;
        $statement->execute(array(
            "empresaid" => $empresaid,
            "finicio"=>$inicio,
            "ffin"=>$fin,
            "zona"=>$zona
        ));
        
        $rpt = $statement->fetchAll(PDO::FETCH_OBJ);
        
        return $rpt;
    } 
    
    
    
}